/* ====================================================================
 * ===  Copyright (C) 1998-2003 Yutaka Sagiya. All rights reserved. ===
 * ====================================================================
 * 
 *    Project              : SagCAD
 *    Description          : CAD/CAM
 *    Source               : List_Ellipse.c
 * 
 *    ----------------------------------
 * 
 *    Copyright            : (C) 1998-2003 by Yutaka Sagiya
 *    email                : kappa@a6s.highway.ne.jp
 *                         : yutaka@sagiya.com
 *    Begin                : 2003/03/25
 *    Last                 : 2003/03/25
 * ====================================================================
 */

#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "MemoryLeak.h"
#include "types.h"
#include "List_Undo.h"
#include "Trace.h"

#define _LIST_ELLIPSE_
#include "List_Ellipse.h"





/* ELLIPSE Data ν */
int init_ellipse(ELLIPSE *ellipse)
{
	ellipse->layer = 0;
	ellipse->color = 0xffffff;
	ellipse->style = 0;
	ellipse->cx = 0;
	ellipse->cy = 0;
	ellipse->dx = 0;
	ellipse->dy = 0;
	ellipse->k = 1;
	ellipse->k = 0;
	ellipse->k = 360;
	return 1;
}





/* -------------------------------------------------------------------
 * ΰݺѤߤ ELLIPSE Data ꥹȤκǽɲ
 * 
 */
ELLIPSE_LIST *r_ellipse_list_add_first(ELLIPSE *add_ellipse, ELLIPSE_LIST_INFO *p_ellipse_list_info)
{
	ELLIPSE_LIST *p;


	/* ǡ (LIST) 񤭹िΰݤ */
	p_ellipse_list = (ELLIPSE_LIST *)xmalloc(sizeof(ELLIPSE_LIST));

	/* ݤΰ˥ǡ (ellipse) 񤭹 */
	p_ellipse_list->ellipse = add_ellipse;
	p_ellipse_list->next = NULL;

	/* -----------------------------------------------------
	 * head & tail ξ NULL ΤȤϡĤǡʤ 
	 */
	if (p_ellipse_list_info->head == NULL && p_ellipse_list_info->tail == NULL) {
		p_ellipse_list_info->head = p_ellipse_list;
		p_ellipse_list_info->tail = p_ellipse_list;
	}

	/* -----------------------------------------------------
	 * ǡİʾ夢
	 */
	else {
		p = p_ellipse_list_info->head;
		p_ellipse_list_info->head = p_ellipse_list;
		p_ellipse_list->next = p;
	}

	return p_ellipse_list_info->head;
}





/* -------------------------------------------------------------------
 * ELLIPSE Data ꥹȤκǽɲ
 * 
 */
ELLIPSE_LIST *ellipse_list_add_first(ELLIPSE *add_ellipse, ELLIPSE_LIST_INFO *p_ellipse_list_info)
{
	ELLIPSE_LIST *p;


	/* ǡ (LIST) 񤭹िΰݤ */
	p_ellipse_list = (ELLIPSE_LIST *)xmalloc(sizeof(ELLIPSE_LIST));
	/* ǡ (ellipse) 񤭹िΰݤ */
	p_ellipse_list->ellipse = (ELLIPSE *)xmalloc(sizeof(ELLIPSE));

	/* ݤΰ˥ǡ (ellipse) 񤭹 */
	*p_ellipse_list->ellipse = *add_ellipse;
	p_ellipse_list->next = NULL;

	/* -----------------------------------------------------
	 * head & tail ξ NULL ΤȤϡĤǡʤ 
	 */
	if (p_ellipse_list_info->head == NULL && p_ellipse_list_info->tail == NULL) {
		p_ellipse_list_info->head = p_ellipse_list;
		p_ellipse_list_info->tail = p_ellipse_list;
	}

	/* -----------------------------------------------------
	 * ǡİʾ夢
	 */
	else {
		p = p_ellipse_list_info->head;
		p_ellipse_list_info->head = p_ellipse_list;
		p_ellipse_list->next = p;
	}

	return p_ellipse_list_info->head;
}





/* -------------------------------------------------------------------
 * ELLIPSE Data ꥹȤκǽɲäơ Undo Baffer ˽
 *	
 */
ELLIPSE_LIST *ellipse_list_add_first_with_undo(ELLIPSE *add_ellipse, ELLIPSE_LIST_INFO *p_ellipse_list_info)
{
	ELLIPSE_LIST *p;
	ELLIPSE ellipse = {0,0,0, 0,0,0,0,0,0,0};

	DIAGRAM diagram;
	LPDIAGRAM lpdiagram;


	/* ǡ (LIST) 񤭹िΰݤ */
	p_ellipse_list = (ELLIPSE_LIST *)xmalloc(sizeof(ELLIPSE_LIST));
	/* ǡ (ellipse) 񤭹िΰݤ */
	p_ellipse_list->ellipse = (ELLIPSE *)xmalloc(sizeof(ELLIPSE));

	/* ݤΰ˥ǡ (ellipse) 񤭹 */
	*p_ellipse_list->ellipse = *add_ellipse;
	p_ellipse_list->next = NULL;

	/* -----------------------------------------------------
	 * head & tail ξ NULL ΤȤϡĤǡʤ 
	 */
	if (p_ellipse_list_info->head == NULL && p_ellipse_list_info->tail == NULL) {
		p_ellipse_list_info->head = p_ellipse_list;
		p_ellipse_list_info->tail = p_ellipse_list;
	}

	/* -----------------------------------------------------
	 * ǡİʾ夢
	 */
	else {
		p = p_ellipse_list_info->head;
		p_ellipse_list_info->head = p_ellipse_list;
		p_ellipse_list->next = p;
	}

	lpdiagram.ellipse_point = p_ellipse_list_info->head->ellipse;
	diagram.ellipse = ellipse;

	/* Undo Buffa Write */
	undo_list_add_first(ELLIPSE_NEW, lpdiagram, diagram);
	return p_ellipse_list_info->head;
}





/* -------------------------------------------------------------------
 * ELLIPSE Data ꥹȤκǸɲ
 * 
 */
ELLIPSE_LIST *ellipse_list_add_last(ELLIPSE *add_ellipse, ELLIPSE_LIST_INFO *p_ellipse_list_info)
{
	ELLIPSE_LIST *p;


	/* ǡ (LIST) 񤭹िΰݤ */
	p_ellipse_list = (ELLIPSE_LIST *)xmalloc(sizeof(ELLIPSE_LIST));
	/* ǡ (ellipse) 񤭹िΰݤ */
	p_ellipse_list->ellipse = (ELLIPSE *)xmalloc(sizeof(ELLIPSE));

	/* ݤΰ˥ǡ (ellipse) 񤭹 */
	*p_ellipse_list->ellipse = *add_ellipse;
	p_ellipse_list->next = NULL;

	/* -----------------------------------------------------
	 * head & tail ξ NULL ΤȤϡĤǡʤ 
	 */
	if (p_ellipse_list_info->head == NULL && p_ellipse_list_info->tail == NULL) {
		p_ellipse_list_info->head = p_ellipse_list;
		p_ellipse_list_info->tail = p_ellipse_list;
	}

	/* -----------------------------------------------------
	 * head = tail  NULL ǤϤʤȤϡĤǡ
	 */
	else if (p_ellipse_list_info->head != NULL 
				&& p_ellipse_list_info->tail != NULL 
					&& p_ellipse_list_info->head == p_ellipse_list_info->tail) {
		p_ellipse_list_info->head->next = p_ellipse_list;
		p_ellipse_list_info->tail = p_ellipse_list;
	}

	/* -----------------------------------------------------
	 * ǡİʾ夢
	 */
	else {
		p = p_ellipse_list_info->tail;
		p_ellipse_list_info->tail = p_ellipse_list;
		p->next = p_ellipse_list_info->tail;
	}

	/* ɥХåե˽ */
//	undo_list_add_first(11, p_ellipse_list_info->tail, NULL);
	return p_ellipse_list_info->tail;
}





/* -------------------------------------------------------------------
 * ELLIPSE Data ꥹȤκǸɲá Undo Baffer ˽
 *	
 */
ELLIPSE_LIST *ellipse_list_add_last_with_undo(ELLIPSE *add_ellipse, ELLIPSE_LIST_INFO *p_ellipse_list_info)
{
	ELLIPSE_LIST *p;
	ELLIPSE ellipse = {0,0,0, 0,0,0,0,0,0,0};

	DIAGRAM diagram;
	LPDIAGRAM lpdiagram;


	/* ǡ (LIST) 񤭹िΰݤ */
	p_ellipse_list = (ELLIPSE_LIST *)xmalloc(sizeof(ELLIPSE_LIST));
	/* ǡ (ellipse) 񤭹िΰݤ */
	p_ellipse_list->ellipse = (ELLIPSE *)xmalloc(sizeof(ELLIPSE));

	/* ݤΰ˥ǡ (ellipse) 񤭹 */
	*p_ellipse_list->ellipse = *add_ellipse;
	p_ellipse_list->next = NULL;

	/* -----------------------------------------------------
	 * head & tail ξ NULL ΤȤϡĤǡʤ 
	 */
	if (p_ellipse_list_info->head == NULL && p_ellipse_list_info->tail == NULL) {
		p_ellipse_list_info->head = p_ellipse_list;
		p_ellipse_list_info->tail = p_ellipse_list;
	}

	/* -----------------------------------------------------
	 * head = tail  NULL ǤϤʤȤϡĤǡ
	 */
	else if (p_ellipse_list_info->head != NULL 
				&& p_ellipse_list_info->tail != NULL 
					&& p_ellipse_list_info->head == p_ellipse_list_info->tail) {
		p_ellipse_list_info->head->next = p_ellipse_list;
		p_ellipse_list_info->tail = p_ellipse_list;
	}

	/* -----------------------------------------------------
	 * ǡİʾ夢
	 */
	else {
		p = p_ellipse_list_info->tail;
		p_ellipse_list_info->tail = p_ellipse_list;
		p->next = p_ellipse_list_info->tail;
	}

	lpdiagram.ellipse_point = p_ellipse_list_info->tail->ellipse;
	diagram.ellipse = ellipse;

	/* Undo Buffa Write */
	undo_list_add_first(ELLIPSE_NEW, lpdiagram, diagram);
	return p_ellipse_list_info->tail;
}





/* -------------------------------------------------------------------
 * ELLIPSE Data κǽ (κǤϤʤ)
 * 
 */
int ellipse_list_delete(ELLIPSE_LIST *del_List, ELLIPSE_LIST_INFO *p_ellipse_list_info)
{
	ELLIPSE_LIST *p = NULL;
	ELLIPSE_LIST *pb = NULL;


	/* ǡƬǣĤ  */
	if (del_List == p_ellipse_list_info->head && del_List->next == NULL) {
		p_ellipse_list_info->head = NULL;
		p_ellipse_list_info->tail = NULL;
	}
	/* ǡƬǣİʾ  */
	else if (del_List == p_ellipse_list_info->head && del_List->next != NULL) {
		p_ellipse_list_info->head = p_ellipse_list_info->head->next;
	}
	else {
		/* -------------------------------------------
		 * ݥ󥿤ΥǡΤꤿΤǡ
		 * head (ꥹȤƬ) ݥ󥿤
		 * ĤޤǷ֤Υǡõ
		 */
		p = p_ellipse_list_info->head;
		/* -------------------------------------------
		 * ǸޤǸĤʤ硢 p  NULL  
		 * äƥ롼פȴ롣
		 */
		while(p != NULL && p != del_List) {
			pb = p;			/* ΥǡΥݥ󥿤Ȥ¸Ƥ */
			p = p->next;	/* ݥ󥿤򼡤Υǡ˰ܤ */
		}

		if(p != NULL){
			/* ǸΥǡ */
			if (del_List == p_ellipse_list_info->tail) {
				pb->next = NULL;
				p_ellipse_list_info->tail = pb;
			}
			/* ֤Υǡ */
			else if (del_List != p_ellipse_list_info->head && del_List != p_ellipse_list_info->tail) {
				pb->next = p->next;
			}
		}
		else {
			g_print("List_ellipse.c : ellipse_list_delete() : ꥹȤ ELLIPSE ǡǤϤʤ\n");
			return 0;
		}
	}
	xfree(del_List);
//	StartData = p_ellipse_list_info->head;
	return 1;
}





/* -------------------------------------------------------------------
 * ELLIPSE Data κǽ (κǤϤʤUndo Buffer ذܤ)
 * 
 */
int ellipse_list_delete_Undo(ELLIPSE_LIST *del_List, ELLIPSE_LIST_INFO *p_ellipse_list_info)
{
	ELLIPSE_LIST *p = NULL;
	ELLIPSE_LIST *pb = NULL;

	DIAGRAM diagram;
	LPDIAGRAM lpdiagram;


	/* ǡƬǣĤ  */
	if (del_List == p_ellipse_list_info->head && del_List->next == NULL) {
		p_ellipse_list_info->head = NULL;
		p_ellipse_list_info->tail = NULL;
	}
	/* ǡƬǣİʾ  */
	else if (del_List == p_ellipse_list_info->head && del_List->next != NULL) {
		p_ellipse_list_info->head = p_ellipse_list_info->head->next;
	}
	else {
		/* -------------------------------------------
		 * ݥ󥿤ΥǡΤꤿΤǡ
		 * head (ꥹȤƬ) ݥ󥿤
		 * ĤޤǷ֤Υǡõ
		 */
		p = p_ellipse_list_info->head;
		/* -------------------------------------------
		 * ǸޤǸĤʤ硢 p  NULL  
		 * äƥ롼פȴ롣
		 */
		while(p != NULL && p != del_List) {
			pb = p;			/* ΥǡΥݥ󥿤Ȥ¸Ƥ */
			p = p->next;	/* ݥ󥿤򼡤Υǡ˰ܤ */
		}

		if(p != NULL){
			/* ǸΥǡ */
			if (del_List == p_ellipse_list_info->tail) {
				pb->next = NULL;
				p_ellipse_list_info->tail = pb;
			}
			/* ֤Υǡ */
			else if (del_List != p_ellipse_list_info->head && del_List != p_ellipse_list_info->tail) {
				pb->next = p->next;
			}
		}
		else {
			g_print("List_ellipse.c : ellipse_list_delete() : ꥹȤ ELLIPSE ǡǤϤʤ\n");
			return 0;
		}
	}

	lpdiagram.ellipse_point = del_List->ellipse;
	diagram.ellipse = *del_List->ellipse;

	undo_list_add_first(ELLIPSE_DEL, lpdiagram, diagram);
	xfree(del_List);
//	StartData = p_ellipse_list_info->head;
	return 1;
}





/* -------------------------------------------------------------------
 * ELLIPSE Υݥ󥿤Υǡ Undo ХåեԽˤơ
 * ξ˿ǡ롣
 *	
 * ͡ΥǡΥɥ쥹
 */
ELLIPSE_LIST *ellipse_list_edit(ELLIPSE_LIST *point, ELLIPSE *change_ellipse, ELLIPSE_LIST_INFO *p_ellipse_list_info)
{
	/* ǡ (LIST) 񤭹िΰݤ */
	p_ellipse_list = (ELLIPSE_LIST *)xmalloc(sizeof(ELLIPSE_LIST));

	/* ǡ (ellipse) 񤭹िΰݤ */
	p_ellipse_list->ellipse = (ELLIPSE *)xmalloc(sizeof(ELLIPSE));

	/* ݤΰѹΥǡ (ellipse) 񤭹 */
	*p_ellipse_list->ellipse = *point->ellipse;
	p_ellipse_list->next = point;

	/* ѹǡ񤭹 */
	*point->ellipse = *change_ellipse;

//	undo_list_add_first(13, p_ellipse_list, NULL);
	return p_ellipse_list;
}





/* -------------------------------------------------------------------
 * ELLIPSE Υݥ󥿤Υǡ Undo ХåեԽˤơ
 * ξ˿ǡ졢Undo Baffer ˽
 *	
 * ͡ΥǡΥɥ쥹
 */
ELLIPSE_LIST *ellipse_list_edit_with_undo(ELLIPSE_LIST *point, ELLIPSE *change_ellipse, ELLIPSE_LIST_INFO *p_ellipse_list_info)
{
	ELLIPSE ellipse = {0,0,0, 0,0,0,0,0,0,0};

	DIAGRAM diagram;
	LPDIAGRAM lpdiagram;


	/* ݤΰѹΥǡ (ELLIPSE) 񤭹 */
	ellipse = *point->ellipse;

	/* ѹǡ񤭹 */
	*point->ellipse = *change_ellipse;

	lpdiagram.ellipse_point = point->ellipse;
	diagram.ellipse = ellipse;

	undo_list_add_first(ELLIPSE_EDIT, lpdiagram, diagram);
	return point;
}





/* -------------------------------------------------------------------
 *	ꥹȤĴ٤
 */
long ellipse_list_num(ELLIPSE_LIST_INFO *p_ellipse_list_info)
{
	ELLIPSE_LIST *p;
	long i;

	p = p_ellipse_list_info->head;
	i = 0;
	/* -------------------------------------------
	 * ǸޤǸĤʤ硢 p  NULL  
	 * äƥ롼פȴ롣
	 */
	while(p != NULL) {
		i++;
		p = p->next;	/* ݥ󥿤򼡤Υǡ˰ܤ */
	}
	return i;
}





/* -------------------------------------------------------------------
 * n ܤΥǡθ
 * 
 */
ELLIPSE_LIST *ellipse_search_num(long search_number, ELLIPSE_LIST_INFO *p_ellipse_list_info)
{
	ELLIPSE_LIST *p;
	long i;


	p = p_ellipse_list_info->head;
	i = 1;
	/*	*/
	while( p != NULL && i != search_number) {
		i++;
		p = p->next;
	}

	/* n ܤΥǡΥɥ쥹֤ */
	if (p != NULL) {
		return p;
	}
	/* ޤǥǡʤ */
	else {
		return NULL;
	}
}





/* -------------------------------------------------------------------
 * ELLIPSE Υǡθ
 * 
 *   ELLIPSE_LIST
 */
ELLIPSE_LIST *ellipse_search_ellipse(ELLIPSE *p_ellipse, ELLIPSE_LIST_INFO *p_ellipse_list_info)
{
	ELLIPSE_LIST *p;


	p = p_ellipse_list_info->head;
	/*	*/
	while( p != NULL && p->ellipse != p_ellipse) {
		p = p->next;
	}

	/* p_ellipse ΥǡΥɥ쥹֤ */
	if (p != NULL) {
		return p;
	}
	/* ޤǥǡʤ */
	else {
		return NULL;
	}
}





/* -------------------------------------------------------------------
 * ELLIPSE Υǡθ
 * 
 *   long
 */
long ellipse_search_ellipse_to_num(ELLIPSE *p_ellipse, ELLIPSE_LIST_INFO *p_ellipse_list_info)
{
	ELLIPSE_LIST *p;
	long i;

	i = 1;
	p = p_ellipse_list_info->head;
	/*	*/
	while( p != NULL && p->ellipse != p_ellipse) {
		p = p->next;
		i++;
	}

	/* p_ellipse ΥǡΥɥ쥹֤ */
	if (p != NULL) {
		return i;
	}
	/* ޤǥǡʤ */
	else {
		return 0;
	}
}





/* -------------------------------------------------------------------
 *	ELLIPSE Data ꥹȤ
 */
int ellipse_list_free(ELLIPSE_LIST *del_List, ELLIPSE_LIST_INFO *p_ellipse_list_info)
{
	ELLIPSE_LIST *p = NULL;
	ELLIPSE_LIST *pb = NULL;


	/* ǡƬǣĤ  */
	if (del_List == p_ellipse_list_info->head && del_List->next == NULL) {
		p_ellipse_list_info->head = NULL;
		p_ellipse_list_info->tail = NULL;
	}
	/* ǡƬǣİʾ  */
	else if (del_List == p_ellipse_list_info->head && del_List->next != NULL) {
		p_ellipse_list_info->head = p_ellipse_list_info->head->next;
	}
	else {
		/* -------------------------------------------
		 * ݥ󥿤ΥǡΤꤿΤǡ
		 * head (ꥹȤƬ) ݥ󥿤
		 * ĤޤǷ֤Υǡõ
		 */
		p = p_ellipse_list_info->head;
		/* -------------------------------------------
		 * ǸޤǸĤʤ硢 p  NULL  
		 * äƥ롼פȴ롣
		 */
		while(p != NULL && p != del_List) {
			pb = p;			/* ΥǡΥݥ󥿤Ȥ¸Ƥ */
			p = p->next;	/* ݥ󥿤򼡤Υǡ˰ܤ */
		}


		if(p != NULL){
			/* ǸΥǡ */
			if (del_List == p_ellipse_list_info->tail) {
				pb->next = NULL;
				p_ellipse_list_info->tail = pb;
			}
			/* ֤Υǡ */
			else if (del_List != p_ellipse_list_info->head && del_List != p_ellipse_list_info->tail) {
				pb->next = p->next;
			}
		}
		else {
			g_print("List_ellipse.c : ellipse_list_free() : ꥹȤ ELLIPSE ǡǤϤʤ\n");
			return 0;
		}
	}
	xfree(del_List->ellipse);
	xfree(del_List);
	return 1;
}





/* -------------------------------------------------------------------
 *	ꥹȤ
 */
void ellipse_list_all_free(ELLIPSE_LIST_INFO *p_ellipse_list_info)
{
	while(p_ellipse_list_info->head != NULL) {
		if (ellipse_list_free(p_ellipse_list_info->head, p_ellipse_list_info) == 0) {
			g_print("List_ellipse.c : ellipse_list_all_free() : ellipse_list_free() ǥ顼\n");
			g_print("%s : %d : ellipse_list_all_free() : ERROR\n", __FILE__, __LINE__);
		}
	}
}





void ellipse_list_print(ELLIPSE_LIST_INFO *p_ellipse_list_info)
{
	ELLIPSE_LIST *p;
	int i = 0;

	g_print("----- ELLIPSE ꥹȤɽ -----\n");
	p = p_ellipse_list_info->head;
	while (p != NULL) {
		i++;
		g_print("%d(0x%x) : layer[%d] : color[%d] : style[0x%x]\n", 
					i, (int)p->ellipse, p->ellipse->layer, (int)p->ellipse->color, p->ellipse->style);
		g_print("    濴(%f,%f) Ĺΰ(%f,%f) [ûΡ %f] [ϳ %f] [λ %f]\n", 
					p->ellipse->cx, p->ellipse->cy, p->ellipse->dx, p->ellipse->dy, 
					p->ellipse->k, p->ellipse->sa, p->ellipse->ea);
		p = p->next;
	}
	g_print("-----------------------------\n");
}





/* -------------------------------------------------------------------
 * Ĺ a 
 * 
 */
double get_ellipse_a(ELLIPSE ellipse)
{
	struct RtnDat rtn;

	rtn.sx[1] = ellipse.cx;
	rtn.sy[1] = ellipse.cy;
	rtn.ex[1] = ellipse.cx + ellipse.dx;
	rtn.ey[1] = ellipse.cy + ellipse.dy;
	pp(&rtn);
	return rtn.l;
}


/* -------------------------------------------------------------------
 * û b 
 * 
 */
double get_ellipse_b(ELLIPSE ellipse)
{
	return (get_ellipse_a(ellipse) * ellipse.k);
}


/* -------------------------------------------------------------------
 * ʱߤη
 * 
 */
double get_ellipse_angle(ELLIPSE ellipse)
{
	struct RtnDat rtn;

	rtn.sx[1] = ellipse.cx;
	rtn.sy[1] = ellipse.cy;
	rtn.ex[1] = ellipse.cx + ellipse.dx;
	rtn.ey[1] = ellipse.cy + ellipse.dy;
	la(&rtn);
	angle_check(&rtn.angle);
	return rtn.angle;
}


/* -------------------------------------------------------------------
 * ʱߤλȽ
 * 
 */
int get_ellipse_se_point(ELLIPSE ellipse, POINT *s_point, POINT *e_point)
{
	double RAD, DX, DY;

	/*  */
	RAD = degrad(get_ellipse_angle(ellipse));

	s_point->x = get_ellipse_a(ellipse) * cos(degrad(ellipse.sa)) + ellipse.cx;
	s_point->y = get_ellipse_b(ellipse) * sin(degrad(ellipse.sa)) + ellipse.cy;

	DX = s_point->x - ellipse.cx;
	DY = s_point->y - ellipse.cy;
	s_point->x = sg((DX * cos(RAD) - DY * sin(RAD)) + ellipse.cx, calcu_digits);
	s_point->y = sg((DY * cos(RAD) + DX * sin(RAD)) + ellipse.cy, calcu_digits);


	/*  */
	RAD = degrad(get_ellipse_angle(ellipse));

	e_point->x = get_ellipse_a(ellipse) * cos(degrad(ellipse.ea)) + ellipse.cx;
	e_point->y = get_ellipse_b(ellipse) * sin(degrad(ellipse.ea)) + ellipse.cy;

	DX = e_point->x - ellipse.cx;
	DY = e_point->y - ellipse.cy;
	e_point->x = sg((DX * cos(RAD) - DY * sin(RAD)) + ellipse.cx, calcu_digits);
	e_point->y = sg((DY * cos(RAD) + DX * sin(RAD)) + ellipse.cy, calcu_digits);

	return 1;
}


/* -------------------------------------------------------------------
 * ʱߤξ
 * 
 */
int get_ellipse_focus(ELLIPSE ellipse, POINT *focus1, POINT *focus2)
{
	double a, b, angle;


	a = get_ellipse_a(ellipse);
	b = get_ellipse_b(ellipse);
	angle = get_ellipse_angle(ellipse);

	/*  */
	focus1->x = -1 * (sqrt(a*a - b*b)) + ellipse.cx;
	focus1->y = 0 + ellipse.cy;
	focus2->x = sqrt(a*a - b*b) + ellipse.cx;
	focus2->y = 0 + ellipse.cy;

	rotation(&focus1->x, &focus1->y, ellipse.cx, ellipse.cy, angle);
	rotation(&focus2->x, &focus2->y, ellipse.cx, ellipse.cy, angle);

	return 1;
}


/* -------------------------------------------------------------------
 * ʱ߾鷹ƤʤȤʱ߾γ٤
 * 
 */
double get_ellipse_point_angle(ELLIPSE ellipse, POINT *point)
{
	struct RtnDat LAH;


	rotation(&point->x, &point->y, ellipse.cx, ellipse.cy, (-1 * get_ellipse_angle(ellipse)));

	/* -------------------------------------------------------------------
	 * la : ľγ
	 */
	LAH.sx[1] = ellipse.cx;
	LAH.sy[1] = ellipse.cy;
	LAH.ex[1] = point->x;
	LAH.ey[1] = point->y;
	la(&LAH);
	angle_check(&LAH.angle);

	return LAH.angle;
}





/* -------------------------------------------------------
 *  (px, py) ϡʱ߾Ǥ뤫Ƚ
 * 
 */
int point_on_ellipse (ELLIPSE *ellipse, double px, double py)
{
//#define POINT_ON_ELLIPSE
	struct RtnDat rtn;
	double a, b, angle;
	double l1, l2, pic_angle;
	POINT focus1, focus2;
	int debug = 0;

	double x1, y1, x2, y2;


#ifdef POINT_ON_ELLIPSE
	debug = 1;
	if (debug > 0) g_print("List_Ellipse.c : point_on_ellipse() : in\n");
#endif


	/* -----------------------------------------------------
	 * ʱߤǤ
	 */
	/* 濴Ĺΰ֤γ٤ȵΥ */
	angle = get_ellipse_angle(*ellipse);
	a = get_ellipse_a(*ellipse);
	b = get_ellipse_b(*ellipse);
	get_ellipse_focus(*ellipse, &focus1, &focus2);

	if (debug > 0) {
		g_print("List_Ellipse.c : point_on_ellipse() : a = %f  b = %f  angle = %f   (%f,%f) (%f,%f)\n", 
				 a, b, angle, focus1.x, focus1.y, focus2.x, focus2.y);
	}



	/* (px,py)  εΥδطǡDC2ܤȽ */
	/* -------------------------------------------------------------------
	 * pp : [9] ֤εΥ
	 */
	rtn.sx[1] = x1;
	rtn.sy[1] = y1;
	rtn.ex[1] = px;
	rtn.ey[1] = py;
	pp(&rtn);
	l1 = rtn.l;

	rtn.sx[1] = x2;
	rtn.sy[1] = y2;
	rtn.ex[1] = px;
	rtn.ey[1] = py;
	pp(&rtn);
	l2 = rtn.l;

	if (debug > 0) g_print("List_Ellipse.c : point_on_ellipse() : (l1 + l2) = %f    (2 X a) = %f\n", l1 + l2, 2*a);

	/* (l1 + l2) = 2a ʤ Ellipse α߼ */
	if ( 
		 (l1 + l2) + (1/pow(10, compa_digits)) > (2*a) 
		 && 
		 (l1 + l2) - (1/pow(10, compa_digits)) < (2*a) 
		) 
	{
		if (debug > 0) g_print("List_Ellipse.c : point_on_ellipse() : Click On Ellipse\n");
		//
	}

	/* Ellipse α߼ǤϤʤ */
	else {
		if (debug > 0) g_print("List_Ellipse.c : point_on_ellipse() : Click Not On Ellipse\n");
		return 0;
	}



	/* ϳѡλѤȽ */
	/* ԥåʱߤФ٤ */
	/* -------------------------------------------------------------------
	 * la : [8] ľγ
	 */
	rtn.sx[1] = ellipse->cx;
	rtn.sy[1] = ellipse->cy;
	rtn.ex[1] = px;
	rtn.ey[1] = py;
	la(&rtn);
	pic_angle = rtn.angle - angle;
	angle_check(&pic_angle);


	if (debug > 0) {
		g_print("List_Ellipse.c : point_on_ellipse() : pic_angle = %f  Ellipse sa = %f  ea = %f\n", 
				 pic_angle, ellipse->sa, ellipse->ea);
	}


	/* SA < EA */
	if (ellipse->sa < ellipse->ea) {
		if (debug > 0) g_print("List_Ellipse.c : point_on_ellipse() : sa (%f) < ea (%f)\n", ellipse->sa, ellipse->ea);

		if (pic_angle > ellipse->sa && pic_angle < ellipse->ea) {
			if (debug > 0) g_print("List_Ellipse.c : point_on_ellipse() : sa < pic (%f) < ea ---> OK !!\n", pic_angle);
			return 1;
		}
	}

	/* SA > EA */
	else if (ellipse->sa > ellipse->ea) {
		if (debug > 0) g_print("List_Ellipse.c : point_on_ellipse() : sa (%f) > ea (%f)\n", ellipse->sa, ellipse->ea);

		if (pic_angle > ellipse->sa || pic_angle < ellipse->ea) {
			if (debug > 0) g_print("List_Ellipse.c : point_on_ellipse() : pic (%f) > sa  pic (%f) < ea ---> OK !!\n", 
					pic_angle, pic_angle);
			return 1;
		}
	}
	else {
		return 0;
	}

	return 0;
}





/* ====================================================================
 * ===  Copyright (C) 1998-2003 Yutaka Sagiya. All rights reserved. ===
 * ====================================================================
 *    Project              : SagCAD
 *    Source               : List_Ellipse.c
 * ====================================================================
 */
