/* ============================================================
 * == Copyright (C) 2001 Yutaka Sagiya. All rights reserved. ==
 * ============================================================
 *	
 *	  Project			   : SagCAD
 *	  Description		   : CAD/CAM
 *	  Source			   : TrimFunc.c
 *	
 *	  ----------------------------------
 *	
 *	  Copyright 		   : (C) 1999 by Yutaka Sagiya
 *	  email 			   : kappa@a6s.highway.ne.jp
 *						   : yutaka@sagiya.com
 *	  Begin 			   : 2001/01/18
 *	  Last				   : 2002/07/28
 * ============================================================
 */

#ifdef WIN32
#include <windows.h>
#endif

#ifdef LINUX
#include <gtk/gtk.h>
#include <unistd.h>
#include <pwd.h>
#include <sys/types.h>
#include <sys/stat.h>
#endif

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "ver.h"
#include "MemoryLeak.h"
#include "List_cad.h"
#include "List_Dimension.h"
#include "List_PolyLine.h"
#include "List_Block.h"
#include "List_Undo.h"
#include "List_Select.h"
#include "Trace.h"
#include "Dimension.h"
#include "etc.h"
#include "global.h"
#include "Draw.h"
#include "Select.h"
#include "Dimension.h"
#define _TRIMFUNC_
#include "TrimFunc.h"





/* -------------------------------------------------------------------
 * ȥȽ
 *	
 */
int TrimMain(struct TrimDat *a)
{
	struct TrimDat Both;
	int Ret;
	double x1, y1, x2, y2, dumy_x, dumy_y;


	/* ȥ޷ʤȥ¹ */
	if (a->TraceData[1].code == 1 ) {
		Ret = TrimL(a, &x1, &y1);
		TrimL_Run(a, x1, y1);
		if (a->Index == 2 && a->TraceData[2].code != 4 ) {
			Both.Index			= 1;
			Both.TraceData[1]	= a->TraceData[2];
			Both.PicX[1]		= a->PicX[2];
			Both.PicY[1]		= a->PicY[2];
			Both.TraceData[2]	= a->TraceData[1];
			Both.PicX[2]		= a->PicX[1];
			Both.PicY[2]		= a->PicY[1];

			if (Both.TraceData[1].code == 1) {
				TrimL_Run(&Both, x1, y1);
			}
			if (Both.TraceData[1].code == 2) {
				Ret = TrimA(&Both, &dumy_x, &dumy_y);
				if (Ret == 1) {
					TrimA_Run(&Both, x1, y1);
				}
				else if (Ret == 2) {
					TrimA_Pull(&Both, x1, y1);
				}
			}

			/* ᤹ */
			a->TraceData[2]		= Both.TraceData[1];
			a->PicX[2]			= Both.PicX[1];
			a->PicY[2]			= Both.PicY[1];
		}
	}

	/* ȥ޷߸̤ʤȥ¹ */
	else if (a->TraceData[1].code == 2 ) {
		Ret = TrimA(a, &x1, &y1);
		if (Ret == 1) {
			TrimA_Run(a, x1, y1);
		}
		else if (Ret == 2) {
			TrimA_Pull(a, x1, y1);
		}
		if (a->Index == 2 && a->TraceData[2].code != 4) {
			Both.Index			= 1;
			Both.TraceData[1]	= a->TraceData[2];
			Both.PicX[1]		= a->PicX[2];
			Both.PicY[1]		= a->PicY[2];
			Both.TraceData[2]	= a->TraceData[1];
			Both.PicX[2]		= a->PicX[1];
			Both.PicY[2]		= a->PicY[1];

			if (Both.TraceData[1].code == 1) {
				TrimL_Run(&Both, x1, y1);
			}
			if (Both.TraceData[1].code == 2) {
				Ret = TrimA(&Both, &dumy_x, &dumy_y);
				if (Ret == 1) {
					TrimA_Run(&Both, x1, y1);
				}
				else if (Ret == 2) {
					TrimA_Pull(&Both, x1, y1);
				}
			}

			/* ᤹ */
			a->TraceData[2]		= Both.TraceData[1];
			a->PicX[2]			= Both.PicX[1];
			a->PicY[2]			= Both.PicY[1];
		}
	}

	/* ȥ޷ߤʤȥ¹ */
	else if (a->TraceData[1].code == 4) {
		Ret = TrimC(a, &x1, &y1, &x2, &y2);
		TrimC_Run(a, &x1, &y1, &x2, &y2);
		if (a->Index == 2 && a->TraceData[2].code != 4) {
			Both.Index			= 1;
			Both.TraceData[1]	= a->TraceData[2];
			Both.PicX[1]		= a->PicX[2];
			Both.PicY[1]		= a->PicY[2];
			Both.TraceData[2]	= a->TraceData[1];
			Both.PicX[2]		= a->PicX[1];
			Both.PicY[2]		= a->PicY[1];

			if (Both.TraceData[1].code == 1) {
				TrimL_Run(&Both, x1, y1);
			}
			if (Both.TraceData[1].code == 2) {
				Ret = TrimA(&Both, &dumy_x, &dumy_y);
				if (Ret == 1) {
					TrimA_Run(&Both, x1, y1);
				}
				else if (Ret == 2) {
					TrimA_Pull(&Both, x1, y1);
				}
			}
			/* ᤹ */
			a->TraceData[2]		= Both.TraceData[1];
			a->PicX[2]			= Both.PicX[1];
			a->PicY[2]			= Both.PicY[1];
		}
		if (a->Index == 2 && a->TraceData[3].code != 4) {
			Both.Index			= 1;
			Both.TraceData[1]	= a->TraceData[3];
			Both.PicX[1]		= a->PicX[3];
			Both.PicY[1]		= a->PicY[3];
			Both.TraceData[2]	= a->TraceData[1];
			Both.PicX[2]		= a->PicX[1];
			Both.PicY[2]		= a->PicY[1];

			if (Both.TraceData[1].code == 1) {
				TrimL_Run(&Both, x2, y2);
			}
			if (Both.TraceData[1].code == 2) {
				Ret = TrimA(&Both, &dumy_x, &dumy_y);
				if (Ret == 1) {
					TrimA_Run(&Both, x2, y2);
				}
				else if (Ret == 2) {
					TrimA_Pull(&Both, x2, y2);
				}
			}

			/* ᤹ */
			a->TraceData[3]		= Both.TraceData[1];
			a->PicX[3]			= Both.PicX[1];
			a->PicY[3]			= Both.PicY[1];
		}
	}
	return 1;
}





/* -------------------------------------------------------------------
 * ǥȥह
 */
int TrimL_Point(struct TrimDat a, double *x, double *y)
{
	struct RtnDat PLPH;

	/* ȥ޷()ȶ޷()κǶ */
	PLPH.sx[1] = a.TraceData[1].sx;
	PLPH.sy[1] = a.TraceData[1].sy;
	PLPH.ex[1] = a.TraceData[1].ex;
	PLPH.ey[1] = a.TraceData[1].ey;
	PLPH.sx[2] = a.TraceData[2].sx;
	PLPH.sy[2] = a.TraceData[2].sy;
	plp(&PLPH);

	/* ʤʤ顣 */
	if (PLPH.type == 0) {
		printf("Trim : error : ޤ(Line & Point)");
		return 0;
	}
	/* ᤿Ƕ */
	*x = PLPH.ex[2];
	*y = PLPH.ey[2];
	return 1;
}





/* -------------------------------------------------------------------
 * ǥȥह
 */
int TrimL_Line(struct TrimDat a, double *x, double *y)
{
	struct RtnDat LLPH;

	/* ȥ޷()ȶ޷()θ */
	LLPH.sx[1] = a.TraceData[1].sx;
	LLPH.sy[1] = a.TraceData[1].sy;
	LLPH.ex[1] = a.TraceData[1].ex;
	LLPH.ey[1] = a.TraceData[1].ey;
	LLPH.sx[2] = a.TraceData[2].sx;
	LLPH.sy[2] = a.TraceData[2].sy;
	LLPH.ex[2] = a.TraceData[2].ex;
	LLPH.ey[2] = a.TraceData[2].ey;
	llp(&LLPH);
	
	/* ʤʤ */
	if (LLPH.type == 0 ) {
		printf("Trim : error : ޤ(Line & Line)");
		return 0;
	}
	
	/* ᤿ */
	*x = LLPH.sx[3];
	*y = LLPH.sy[3];
	return 1;
}





/* -------------------------------------------------------------------
 * ߤǥȥह
 */
int TrimL_AC(struct TrimDat a, double *x, double *y)
{
	struct RtnDat LCPH, PPH;
	double L1, L2;					/* ȥ޷()ȥȥ޷()θ */


	/* ȥ޷()ȶ޷()θ */
	LCPH.cx[1] = a.TraceData[2].cx;
	LCPH.cy[1] = a.TraceData[2].cy;
	LCPH.r[1] = a.TraceData[2].r;
	LCPH.sx[1] = a.TraceData[1].sx;
	LCPH.sy[1] = a.TraceData[1].sy;
	LCPH.ex[1] = a.TraceData[1].ex;
	LCPH.ey[1] = a.TraceData[1].ey;
	lcp(&LCPH);

	/* ʤʤ */
	if (LCPH.type == 0 ) {
		printf("Trim : error : ޤ(Line & Circle)");
		return 0;
	}

	/* ĤΤȤ */
	else if (LCPH.type == 1 ) {
		/* ᤿ (LCPH.SX[2] , LCPH.SY[2]) */
		*x = LCPH.sx[2];
		*y = LCPH.sy[2];
		return 1;
	}

	/* ĤΤȤ */
	else if (LCPH.type == 2 ) {
		/* å (a.PicX[2] , a.PicY[2])  
		 *  1 (LCPH.sx[2] , LCPH.sy[2]) εΥ L1 롣
		 */
		PPH.sx[1] = a.PicX[2];
		PPH.sy[1] = a.PicY[2];
		PPH.ex[1] = LCPH.sx[2];
		PPH.ey[1] = LCPH.sy[2];
		pp(&PPH);
		L1 = PPH.l;
		/* å (a.PicX[2] , a.PicY[2]) 
		 *  2 (LCPH.SX[3] , LCPH.SY[3]) εΥ L2 롣
		 */
		PPH.sx[1] = a.PicX[2];
		PPH.sy[1] = a.PicY[2];
		PPH.ex[1] = LCPH.sx[3];
		PPH.ey[1] = LCPH.sy[3];
		pp(&PPH);
		L2 = PPH.l;
		/* ɤäθå˶ᤤ
		 * ᤫä(PointX,PointY)
		 */

		/*  1 ᤤ */
		if (L1 < L2) {
			/* ᤿ (LCPH.SX[2] , LCPH.SY[2]) */
			*x = LCPH.sx[2];
			*y = LCPH.sy[2];
			return 1;
		}
		/*  2 ᤤ */
		else/* if (L1 > L2)*/ {
			/* ᤿ (LCPH.SX[3] , LCPH.SY[3]) */
			*x = LCPH.sx[3];
			*y = LCPH.sy[3];
			return 1;
		}
	}
	return 0;
}





/* -------------------------------------------------------------------
 * ȥ¹
 */
int TrimL_Run(struct TrimDat *a, double x, double y)
{
	struct RtnDat PPH, LAH;
	double L;						/* ȥ޷()γ pic1 εΥ */
	double CL;						/* ȥ޷()γȥȥεΥ */
	double SenA;					/* ȥ޷()γ齪λޤǤγ */
	double ClickA;					/* ȥ޷()γȥޤǤγ */

//	double AfterA;

	/* -----------------------------------------------------------
	 * ȥ¹
	 *  (x , y)
	 *  (a.TraceData[1].sx , a.TraceData[1].sy) εΥ L 롣
	 */
	PPH.sx[1] = a->TraceData[1].sx;
	PPH.sy[1] = a->TraceData[1].sy;
	PPH.ex[1] = a->PicX[1];
	PPH.ey[1] = a->PicY[1];
	pp(&PPH);
	L = PPH.l;

	/* ȸ (x , y) εΥ CL 롣 */
	PPH.sx[1] = a->TraceData[1].sx;
	PPH.sy[1] = a->TraceData[1].sy;
	PPH.ex[1] = x;
	PPH.ey[1] = y;
	pp(&PPH);
	CL = PPH.l;

	/* ȥ޷ˤγ SenA 롣 */
	LAH.sx[1] = a->TraceData[1].sx;
	LAH.sy[1] = a->TraceData[1].sy;
	LAH.ex[1] = a->TraceData[1].ex;
	LAH.ey[1] = a->TraceData[1].ey;
	la(&LAH);
	SenA = LAH.angle;

	/* ȥ޷ˤλޤǤγ ClickA 롣 */
	LAH.sx[1] = a->TraceData[1].sx;
	LAH.sy[1] = a->TraceData[1].sy;
	LAH.ex[1] = x;
	LAH.ey[1] = y;
	la(&LAH);
	ClickA = LAH.angle;

	/* γ٤ȥޤǤγ٤Ʊ */
	if (sg(SenA, compa_digits-2) == sg(ClickA, compa_digits-2)) {
		/*  */
		if (L < CL) {
			a->TraceData[1].ex = sg(x, calcu_digits);
			a->TraceData[1].ey = sg(y, calcu_digits);
		}
		/* 饨 */
		if (L > CL) {
			a->TraceData[1].sx = sg(x, calcu_digits);
			a->TraceData[1].sy = sg(y, calcu_digits);
		}
	}

	/* γ٤ȥޤǤγ٤㤦򿭤Ф */
	else { //if (sg(SenA, compa_digits) != sg(ClickA, compa_digits)) {
		a->TraceData[1].sx = x;
		a->TraceData[1].sy = y;
	}


#ifdef TEST
	/* ȥ޷ˤγ AfterA 롣 */
	LAH.sx[1] = a->TraceData[1].sx;
	LAH.sy[1] = a->TraceData[1].sy;
	LAH.ex[1] = a->TraceData[1].ex;
	LAH.ey[1] = a->TraceData[1].ey;
	la(&LAH);
	AfterA = sg(LAH.angle, compa_digits);
	
	if (SenA != AfterA) {
		Swap_double(&a->TraceData[1].sx, &a->TraceData[1].ex);
		Swap_double(&a->TraceData[1].sy, &a->TraceData[1].ey);
	}
#endif
	return 1;
}





/* -------------------------------------------------------------------
 * ȥह
 *	
 *	
 * 
 * 1 : ȥ޷										 error
 *	    ޷(Ƕǥȥ)	   TrimL_Point		 -1
 *	    ޷					   TrimL_Line		 -2
 *	    ޷߸̤ޤϱ		   TrimL_AC 		 -3
 * 2 : ȥ¹
 * -------------------------------------------------------------------
 */
int TrimL(struct TrimDat *a, double *x, double *y)
{
//	double PointX = 0, PointY = 0;	/* ȥहɸ */
	int Ret;


	/* -----------------------------------------------------
	 * 1 : ȥ޷
	 */
	if (a->TraceData[1].code == 1 ) {
		 /*  ޷ */
		if (a->TraceData[2].code == 0 ) {
			/* ȥ޷()ȶ޷()κǶ */
			Ret = TrimL_Point(*a, x, y);
			if (Ret == 0) {
				printf("Trim : error : ޤ(Line & Point)");
				return 0;
			}
		}
		/*  ޷ */
		if (a->TraceData[2].code == 1 ) {
			/* ȥ޷()ȶ޷()θ */
			Ret = TrimL_Line(*a, x, y);
			if (Ret == 0) {
				printf("Trim : error : ޤ(Line & Line)");
				return 0;
			}
		}
		/*  ޷߸̤ޤϱ */
		if (a->TraceData[2].code == 2 || a->TraceData[2].code == 4) {
			/* ȥ޷()ȶ޷()θ */
			Ret = TrimL_AC(*a, x, y);
			if (Ret == 0) {
				printf("Trim : error : ޤ(Line & Circle)");
				return 0;
			}
		}

		/* -----------------------------------------------------------
		 * ȥ¹
		 */
//		return TrimL_Run(a, PointX, PointY);
	}
	return 1;
}





/* -------------------------------------------------------------------
 * ߸̤αĹ
 *	
 * ȥȤƤʬϡΤޤޱĹȱߤˤʤʬǡ
 * ưɤ뤫ǺǤ뤱ɡȤꤢ⤷ʤǤ
 *	
 */
int TrimA_Pull(struct TrimDat *a, double x, double y)
{
	struct RtnDat PPH;
	double CSL, CEL;

	/* ȽΥå˶ᤤü򿭤Ф
	 * åޤǤεΥ
	 */
	PPH.sx[1] = a->PicX[1];
	PPH.sy[1] = a->PicY[1];
	PPH.ex[1] = a->TraceData[1].sx;
	PPH.ey[1] = a->TraceData[1].sy;
	pp(&PPH);
	CSL = PPH.l;
	/* å齪ޤǤεΥ */
	PPH.sx[1] = a->PicX[1];
	PPH.sy[1] = a->PicY[1];
	PPH.ex[1] = a->TraceData[1].ex;
	PPH.ey[1] = a->TraceData[1].ey;
	pp(&PPH);
	CEL = PPH.l;
	/* ǡˡä
	 * ǡ
	 * å˶ᤤ()
	 */
	if (CSL < CEL) {
		/* ȽλƱʤ */
		if (sg(x, compa_digits) == sg(a->TraceData[1].ex, compa_digits)
			&& sg(y, compa_digits) == sg(a->TraceData[1].ey, compa_digits))
		{
/*
			Ret = MessageBox(NULL,	(LPCSTR)"ȽλƱǤ\nߤˤޤ", 
								(LPCSTR)"ǧ" ,	
								MB_YESNO | MB_ICONQUESTION);
			if (Ret == IDYES) {
				a->TraceData[1].code = 4;
				a->TraceData[1].sx = 0;
				a->TraceData[1].sy = 0;
				a->TraceData[1].ex = 0;
				a->TraceData[1].ey = 0;
			}
			else
*/
			return 0;
		}
		else {
			a->TraceData[1].sx = sg(x, calcu_digits);
			a->TraceData[1].sy = sg(y, calcu_digits);
			return 1;
		}
	}


	/* å˶ᤤ(λ) */
	else if (CSL > CEL) {
		/* ȳƱʤߤˤ롣*/
		if (sg(a->TraceData[1].sx, compa_digits) == sg(x, compa_digits) 
			&& sg(a->TraceData[1].sy, compa_digits) == sg(y, compa_digits)) 
		{
/*
			Ret = MessageBox(NULL,	(LPCSTR)"ȳƱǤ\nߤˤޤ", 
								(LPCSTR)"ǧ" ,	
								MB_YESNO | MB_ICONQUESTION);
			if (Ret == IDYES) {
				a->TraceData[1].code = 4;
				a->TraceData[1].sx = 0;
				a->TraceData[1].sy = 0;
				a->TraceData[1].ex = 0;
				a->TraceData[1].ey = 0;
			}
			else
*/
			return 0;
		}
		else {
			a->TraceData[1].ex = sg(x, calcu_digits);
			a->TraceData[1].ey = sg(y, calcu_digits);
			return 1;
		}
	}
	return 0;
}





/* -------------------------------------------------------------------
 * ߸̤Υȥ¹
 *	
 */
int TrimA_Run(struct TrimDat *a, double x, double y)
{
	struct RtnDat LAH;
	double SA, EA, PA, KA;


	/* -----------------------------------------------------------
	 * ߸̥ȥ¹
	 */
	/* ߸̤ SA & EA  */
	SA = Arc_SE_Angle(a->TraceData[1], 0);
	EA = Arc_SE_Angle(a->TraceData[1], 1);
	/* 濴(PointX,PointY)ޤǤγ PA 롣*/
	LAH.sx[1] = a->TraceData[1].cx;
	LAH.sy[1] = a->TraceData[1].cy;
	LAH.ex[1] = x;
	LAH.ey[1] = y;
	la(&LAH);
	PA = sg(LAH.angle, calcu_digits);


	/* ߸̤Υȥ ------------------------------------
	 * 濴ޤǤγ PA
	 * 濴饯åޤǤγ KA롣
	 */
	LAH.sx[1] = a->TraceData[1].cx;
	LAH.sy[1] = a->TraceData[1].cy;
	LAH.ex[1] = a->PicX[1];
	LAH.ey[1] = a->PicY[1];
	la(&LAH);
	KA = sg(LAH.angle, calcu_digits);


	if (SA > EA)	EA = EA + 360;
	if (PA < SA)	PA = PA + 360;
	if (KA < SA)	KA = KA + 360;
	
	/* ǡˡä
	 * SelectColor = 2
	 * SelectCadDraw (A.TraceNumber[1])
	 */
	/* KA<PA */
	if (KA < PA) {
		/* ȳƱʤߤˤ롣*/
		if (sg(a->TraceData[1].sx, compa_digits) == sg(x, compa_digits) 
			&& sg(a->TraceData[1].sy, compa_digits) == sg(y, compa_digits)) 
		{
/*
			Ret = MessageBox(NULL,	(LPCSTR)"ȳƱǤ\nߤˤޤ", 
								(LPCSTR)"ǧ" ,	
								MB_YESNO | MB_ICONQUESTION);
			if (Ret == IDYES) {
				a->TraceData[1].code = 4;
				a->TraceData[1].sx = 0;
				a->TraceData[1].sy = 0;
				a->TraceData[1].ex = 0;
				a->TraceData[1].ey = 0;
			}
			else
*/
			return 0;
		}
		else {
			a->TraceData[1].ex = sg(x, calcu_digits);
			a->TraceData[1].ey = sg(y, calcu_digits);
			return 1;
		}
	}
	/* KA > PA饨 */
	if (KA > PA) {
		/* ȳƱʤߤˤ롣*/
		if (sg(a->TraceData[1].ex, compa_digits) == sg(x, compa_digits) 
			&& sg(a->TraceData[1].ey, compa_digits) == sg(y, compa_digits)) 
		{
/*
			Ret = MessageBox(NULL,	(LPCSTR)"ȽλƱǤ\nߤˤޤ", 
								(LPCSTR)"ǧ" ,	
								MB_YESNO | MB_ICONQUESTION);
			if (Ret == IDYES) {
				a->TraceData[1].code = 4;
				a->TraceData[1].sx = 0;
				a->TraceData[1].sy = 0;
				a->TraceData[1].ex = 0;
				a->TraceData[1].ey = 0;
			}
			else
*/
			return 0;
		}
		else {
			a->TraceData[1].sx = sg(x, calcu_digits);
			a->TraceData[1].sy = sg(y, calcu_digits);
			return 1;
		}
	}
	return 0;
}





/* -------------------------------------------------------------------
 * ߸̤ȥह
 *	
 *  : int	 ERR : 0   OK : 1  Ĺ : 2
 *	
 * 
 * ȥ޷߸̤ʤ
 * 		  ޷(Ƕǥȥ)
 * 		  ޷
 * 		  ޷߸̤ޤϱ
 *	
 * 
 * 		  ߸̤αĹȥθ롣
 *	
 *  SA & EA δ֤ˤʤȤϡå(pic2)˶ᤤü򿭤Ф
 * -------------------------------------------------------------------
 */
int TrimA(struct TrimDat *a, double *x, double *y)
{
	struct RtnDat LAH;
	double SA, EA, PA;


	/* -----------------------------------------------------
	 * 2 : ȥ޷߸
	 */
	if (a->TraceData[1].code == 2) {
		/*  ޷ */
		if (a->TraceData[2].code == 0) {
			if (TrimC_Point(*a, x, y, 2) == 0) {
				printf("Trim : error : ޤ(ARC & Point)");
				return 0;
			}
		}
		/*  ޷ */
		if (a->TraceData[2].code == 1) {
			if (TrimC_Line(*a, x, y, 2) == 0) {
				printf("Trim : error : ޤ(ARC & Line)");
				return 0;
			}
		}
		/*  ޷߸̤ޤϱ */
		if (a->TraceData[2].code == 2 || a->TraceData[2].code == 4) {
			if (TrimC_AC(*a, x, y, 2) == 0) {
				printf("Trim : error : ޤ(ARC & (ARC or Circle))");
				return 0;
			}
		}


		/* -----------------------------------------------------------
		 * ߸̥ȥ¹
		 */
		/* ߸̤ SA & EA  */
		SA = Arc_SE_Angle(a->TraceData[1], 0);
		EA = Arc_SE_Angle(a->TraceData[1], 1);
		/* 濴(PointX,PointY)ޤǤγ PA 롣*/
		LAH.sx[1] = a->TraceData[1].cx;
		LAH.sy[1] = a->TraceData[1].cy;
		LAH.ex[1] = *x;
		LAH.ey[1] = *y;
		la(&LAH);
		PA = sg(LAH.angle, calcu_digits);


		/* ߸̤αĹ --------------------------------------
		 * ߸̾ˤʤȤ
		 */
		if ( 
			((SA < EA) 
			&& (sg(PA, calcu_digits) < sg(SA, calcu_digits) 
			|| sg(PA, calcu_digits) > sg(EA, calcu_digits)))
			|| ((SA > EA) 
			&& (sg(PA, calcu_digits) <= sg(SA, calcu_digits) 
			&& sg(PA, calcu_digits) > sg(EA, calcu_digits)))
			)
		{
			return 2;
			//TrimA_Pull(a, PointX, PointY);
		}


		/* ߸̤Υȥ ------------------------------------
		 * 濴ޤǤγ PA
		 * 濴饯åޤǤγ KA롣
		 */
		return 1;
		//TrimA_Run(a, PointX, PointY, SA, EA, PA);
	}
	return 0;
}





/* -------------------------------------------------------------------
 * CAD DATA α߸̥ǡ顢SA EA 
 *	
 *  : CAD Data, int Frag = (0:SA	1:EA)
 *  : double (Deg)
 */
double Arc_SE_Angle(CAD Data, int Frag)
{
	struct RtnDat rtn;

	/* SA */
	if (Frag == 0) {
		rtn.sx[1] = Data.cx;
		rtn.sy[1] = Data.cy;
		rtn.ex[1] = Data.sx;
		rtn.ey[1] = Data.sy;
		la(&rtn);
		return (rtn.angle);
	}

	/* EA */
	else if (Frag == 1) {
		rtn.sx[1] = Data.cx;
		rtn.sy[1] = Data.cy;
		rtn.ex[1] = Data.ex;
		rtn.ey[1] = Data.ey;
		la(&rtn);
		return (rtn.angle);
	}
	return 0;
}





/* -------------------------------------------------------------------
 * ߤȥहؿΥ
 *	
 * ޷ frag 
 */
int TrimC_Point(struct TrimDat a, double *x, double *y, int frag)
{
	struct RtnDat LAH , PAPH;

	/* ߤ濴˸γ٣롣 */
	LAH.sx[1] = a.TraceData[1].cx;
	LAH.sy[1] = a.TraceData[1].cy;
	LAH.ex[1] = a.TraceData[frag].sx;
	LAH.ey[1] = a.TraceData[frag].sy;
	la(&LAH);
	/* ߤ濴٣Ⱦ¤εΥˤ */
	PAPH.sx[1] = a.TraceData[1].cx;
	PAPH.sy[1] = a.TraceData[1].cy;
	PAPH.angle = LAH.angle;
	PAPH.l = a.TraceData[1].r;
	pap(&PAPH);
	*x = PAPH.ex[1];
	*y = PAPH.ey[1];
	return 1;
}





/* -------------------------------------------------------------------
 * ߤȥहؿΥ
 *	
 * ޷ frag 
 */
int TrimC_Line(struct TrimDat a, double *x, double *y, int frag)
{
	struct RtnDat LCPH, PPH;
	double L1, L2;

	/*	*/
	LCPH.cx[1] = a.TraceData[1].cx;
	LCPH.cy[1] = a.TraceData[1].cy;
	LCPH.r[1]  = a.TraceData[1].r;
	LCPH.sx[1] = a.TraceData[frag].sx;
	LCPH.sy[1] = a.TraceData[frag].sy;
	LCPH.ex[1] = a.TraceData[frag].ex;
	LCPH.ey[1] = a.TraceData[frag].ey;
	lcp(&LCPH);	 // (LCPH.SX[2],LCPH.SY[2])(LCPH.SX[3],LCPH.SY[3])

	/* ʤʤ顣 */
	if (LCPH.type == 0 ) {
		printf("TrimC-1 : error : ޤ");
		return 0;
	}

	/* 	  (LCPH.SX[2],LCPH.SY[2]) */
	else if (LCPH.type == 1 ) {
		/* (LCPH.SX[2],LCPH.SY[2]) */
		*x = LCPH.sx[2];
		*y = LCPH.sy[2];
		return 1;
	}

	/* 	  (LCPH.SX[2],LCPH.SY[2])(LCPH.SX[3],LCPH.SY[3]) */
	else if (LCPH.type == 2 ) {
		/* å(A.PicX[2],A.PicY[2])ȸ(LCPH.SX[2],LCPH.SY[2])εΥ */
		PPH.sx[1] = a.PicX[frag];
		PPH.sy[1] = a.PicY[frag];
		PPH.ex[1] = LCPH.sx[2];
		PPH.ey[1] = LCPH.sy[2];
		pp(&PPH);
		L1 = PPH.l;
		/* å(A.PicX[2],A.PicY[2])ȸ(LCPH.SX[3],LCPH.SY[3])εΥ롣 */
		PPH.sx[1] = a.PicX[frag];
		PPH.sy[1] = a.PicY[frag];
		PPH.ex[1] = LCPH.sx[3];
		PPH.ey[1] = LCPH.sy[3];
		pp(&PPH);
		L2 = PPH.l;
		/* ɤäθå˶ᤤ */
		if (L1 < L2) {
			*x = LCPH.sx[2];
			*y = LCPH.sy[2];
			return 1;
		}
		else if (L1 > L2) {
			*x = LCPH.sx[3];
			*y = LCPH.sy[3];
			return 1;
		}
		/* ᤫä(PointX,PointY) */
	}
	return 0;
}





/* -------------------------------------------------------------------
 * ߤȥहؿΥ
 *	
 * ޷ frag ߸̤ޤϱ
 */
int TrimC_AC(struct TrimDat a, double *x, double *y, int frag)
{
	struct RtnDat PPH, CCPH;
	double L1, L2;

	/* ߤȱߤθ롣 */
	CCPH.cx[1] = a.TraceData[1].cx;
	CCPH.cy[1] = a.TraceData[1].cy;
	CCPH.r[1] = a.TraceData[1].r;
	CCPH.cx[2] = a.TraceData[frag].cx;
	CCPH.cy[2] = a.TraceData[frag].cy;
	CCPH.r[2] = a.TraceData[frag].r;
	ccp(&CCPH);	 /* (CCPH.SX[1],CCPH.SY[1])(CCPH.SX[2],CCPH.SY[2]) */

	/* ʤʤ顣 */
	if (CCPH.type == 0 ) {
		printf("TrimC-3 : error : ޤ");
		return 0;
	}

	/* ĤΤȤ */
	else if (CCPH.type == 1 ) {
		/* (CCPH.SX[1],CCPH.SY[1]) */
		*x = CCPH.sx[1];
		*y = CCPH.sy[1];
		return 1;
	}

	/* ĤΤȤ */
	else if (CCPH.type == 2 ) {
		/* å(A.PicX[2],A.PicY[2])ȸ(LCPH.SX[2],LCPH.SY[2])εΥ롣 */
		PPH.sx[1] = a.PicX[frag];
		PPH.sy[1] = a.PicY[frag];
		PPH.ex[1] = CCPH.sx[1];
		PPH.ey[1] = CCPH.sy[1];
		pp(&PPH);
		L1 = PPH.l;
		/* å(A.PicX[2],A.PicY[2])ȸ(LCPH.SX[3],LCPH.SY[3])εΥ롣 */
		PPH.sx[1] = a.PicX[frag];
		PPH.sy[1] = a.PicY[frag];
		PPH.ex[1] = CCPH.sx[2];
		PPH.ey[1] = CCPH.sy[2];
		pp(&PPH);
		L2 = PPH.l;
		/* ɤäθå˶ᤤ */
		if (L1 < L2) {
			*x = CCPH.sx[1];
			*y = CCPH.sy[1];
			return 1;
		}
		else if (L1 > L2) {
			*x = CCPH.sx[2];
			*y = CCPH.sy[2];
			return 1;
		}
		/* ᤫä(PointX,PointY) */
	}
	return 0;
}





/* -------------------------------------------------------------------
 *  : ߤȥह
 * ؿ : TrimC
 *  : struct TrimDat *
 *  : int
 *		: ERR : 0	 OK : 1
 *  : ̵
 *  : ̵
 *		: 
 * -------------------------------------------------------------------
 * 
 * 1 : ȥ޷
 *		 ޷ 2 
 *		 ޷ 3 
 *		 ޷ 2 
 *		 ޷ 3 
 *		 ޷ 2 ߸̤ޤϱ
 *		 ޷ 3 ߸̤ޤϱ
 *	
 */
int TrimC(struct TrimDat *a, double *x1, double *y1, double *x2, double *y2)
{
	/*  ޷ 2  */
	if (a->TraceData[2].code == 0 ) {
		if (TrimC_Point(*a, x1, y1, 2) == 0)
			return 0;
	}
	/*  ޷ 3  */
	if (a->TraceData[3].code == 0 ) {
		if (TrimC_Point(*a, x2, y2, 3) == 0)
			return 0;
	}
	/*  ޷ 2  */
	if (a->TraceData[2].code == 1 ) {
		if (TrimC_Line(*a, x1, y1, 2) == 0)
			return 0;
	}
	/*  ޷ 3  */
	if (a->TraceData[3].code == 1 ) {
		if (TrimC_Line(*a, x2, y2, 3) == 0)
			return 0;
	}
	/*  ޷2߸ */
	if (a->TraceData[2].code == 2 || a->TraceData[2].code == 4 ) {
		if (TrimC_AC(*a, x1, y1, 2) == 0)
			return 0;
	}
	/*  ޷ 3 ߸ */
	if (a->TraceData[3].code == 2 || a->TraceData[3].code == 4 ) {
		if (TrimC_AC(*a, x2, y2, 3) == 0)
			return 0;
	}

	return 1;
}





/* -------------------------------------------------------------------
 *  : ߤȥह
 * ؿ : TrimC_Run
 *  : struct TrimDat *
 *  : int
 *		: ERR : 0	 OK : 1
 *  : ̵
 *  : ̵
 *		: 
 * -------------------------------------------------------------------
 * 
 * 1 : ȥ޷
 *		 ޷ 2 
 *		 ޷ 3 
 *		 ޷ 2 
 *		 ޷ 3 
 *		 ޷ 2 ߸̤ޤϱ
 *		 ޷ 3 ߸̤ޤϱ
 *	
 */
int TrimC_Run(struct TrimDat *a, double *x1, double *y1, double *x2, double *y2)
{
	struct RtnDat LAH;
	double K1A, K2A, CA;


	/* ---------------------------------------------------------------
	 * ߥȥ¹
	 * 
	 *  ( PointX , PointY ) ( PointX2 , PointY2 )
	 */
	/*  ( PointX , PointY ) γ K1A 롣 */
	LAH.sx[1] = a->TraceData[1].cx;
	LAH.sy[1] = a->TraceData[1].cy;
	LAH.ex[1] = *x1;
	LAH.ey[1] = *y1;
	la(&LAH);
	K1A = LAH.angle;
	/*  ( PointX2 , PointY2 ) γ K2A 롣 */
	LAH.sx[1] = a->TraceData[1].cx;
	LAH.sy[1] = a->TraceData[1].cy;
	LAH.ex[1] = *x2;
	LAH.ey[1] = *y2;
	la(&LAH);
	K2A = LAH.angle;
	/* å ( A.PicX[1] , A.PicY[1] ) γ CA 롣 */
	LAH.sx[1] = a->TraceData[1].cx;
	LAH.sy[1] = a->TraceData[1].cy;
	LAH.ex[1] = a->PicX[1];
	LAH.ey[1] = a->PicY[1];
	la(&LAH);
	CA = LAH.angle;

	/* ǡˡä */
	if (K1A < CA && CA < K2A ) {
		/* START(PointX,PointY)	  END(PointX2,PointY2) */
		a->TraceData[1].code = 2;
		a->TraceData[1].sx = *x1;
		a->TraceData[1].sy = *y1;
		a->TraceData[1].ex = *x2;
		a->TraceData[1].ey = *y2;
	}
	else if (K2A < CA && CA < K1A ) {
		/* START(PointX2,PointY2)	END(PointX,PointY) */
		a->TraceData[1].code = 2;
		a->TraceData[1].sx = *x2;
		a->TraceData[1].sy = *y2;
		a->TraceData[1].ex = *x1;
		a->TraceData[1].ey = *y1;
	}
	else if (((CA > K1A && CA > K2A) || (CA < K1A && CA < K2A)) && K2A > K1A) {
		/* START(PointX2,PointY2)	END(PointX,PointY) */
		a->TraceData[1].code = 2;
		a->TraceData[1].sx = *x2;
		a->TraceData[1].sy = *y2;
		a->TraceData[1].ex = *x1;
		a->TraceData[1].ey = *y1;
	}
	else if (((CA > K1A && CA > K2A) || (CA < K1A && CA < K2A)) && K2A < K1A) {
		/* START(PointX,PointY)	  END(PointX2,PointY2) */
		a->TraceData[1].code = 2;
		a->TraceData[1].sx = *x1;
		a->TraceData[1].sy = *y1;
		a->TraceData[1].ex = *x2;
		a->TraceData[1].ey = *y2;
	}
	return 1;
}





/* -------------------------------------------------------------------
 *  : ߸̤ʬ䤹
 * ؿ : Split
 *  : struct TrimDat *
 *  : int  NewData = a->TraceData[3]
 *		: ERR : 0	 OK : 1
 *  : ̵
 *  : ̵
 *		: 
 * -------------------------------------------------------------------
 * 
 * 1 : ȥ޷ 
 * 		 ޷ (Ƕʬ)
 * 		 ޷ 
 * 		 ޷ ߸̤ޤϱ
 * 2 : ȥ޷ ߸
 * 		 ޷ (Ƕʬ)
 * 		 ޷ 
 * 		 ޷ ߸̤ޤϱ
 * -------------------------------------------------------------------
 */
int Split(struct TrimDat *a)
{
	struct RtnDat LAH;
	double PointX, PointY, SA, EA, PA;


	/* -----------------------------------------------------
	 * 1 : ʬ䤹޷ 
	 */
	if (a->TraceData[1].code == 1) {
		/*  ޷  */
		if (a->TraceData[2].code == 0) {
			if (TrimL_Point(*a, &PointX, &PointY) == 0) {
				printf("Split-10 : error : ޤ");
				return 0;
			}
		}
		/*  ޷  */
		else if (a->TraceData[2].code == 1 ) {
			if (TrimL_Line(*a, &PointX, &PointY) == 0) {
				printf("Split-11 : error : ޤ");
				return 0;
			}
		}
		/*  ޷ ߸̤ޤϱ */
		else if (a->TraceData[2].code == 2 || a->TraceData[2].code == 4) {
			if (TrimL_AC(*a, &PointX, &PointY) == 0) {
				printf("Split-12 : error : ޤ");
				return 0;
			}
		}

		/* -------------------------------------------------
		 * å
		 */
		if ( (sg(PointX, compa_digits) == sg(a->TraceData[1].sx, compa_digits) 
				&& sg(PointY, compa_digits) == sg(a->TraceData[1].sy, compa_digits)) 
				|| (sg(PointX, compa_digits) == sg(a->TraceData[1].ex, compa_digits) 
				&& sg(PointY, compa_digits) == sg(a->TraceData[1].ey, compa_digits)))
		{
			if (sg(PointX, compa_digits) == sg(a->TraceData[1].sx, compa_digits) 
					&& sg(PointY, compa_digits) == sg(a->TraceData[1].sy, compa_digits)) 
			{
				printf("Split : error : ʬƱǤ(LINE)");
			}
			else if (sg(PointX, compa_digits) == sg(a->TraceData[1].ex, compa_digits) 
				&& sg(PointY, compa_digits) == sg(a->TraceData[1].ey, compa_digits)) 
			{
				printf("Split : error : ʬƱǤ(LINE)");
			}
			return 0;
		}

		/* -------------------------------------------------
		 * ʬ¹
		 *  ( PointX , PointY )
		 */

		/* ʬ䤷ƤǤǡ*/
		a->TraceData[3].code = 1;
		a->TraceData[3].layer = a->TraceData[1].layer;
		a->TraceData[3].style = a->TraceData[1].style;
		a->TraceData[3].color = a->TraceData[1].color;
		a->TraceData[3].sx = sg(PointX, calcu_digits);
		a->TraceData[3].sy = sg(PointY, calcu_digits);
		a->TraceData[3].ex = a->TraceData[1].ex;
		a->TraceData[3].ey = a->TraceData[1].ey;

		/* Υǡ */
		a->TraceData[1].ex = sg(PointX, calcu_digits);
		a->TraceData[1].ey = sg(PointY, calcu_digits);
		return 1;
	}





	/* -----------------------------------------------------
	 * 2 : ʬ䤹޷߸
	 */
	else if (a->TraceData[1].code == 2) {
		/*  ޷  */
		if (a->TraceData[2].code == 0 ) {
			if (TrimC_Point(*a, &PointX, &PointY, 2) == 0) {
				printf("Split-20 : error : ޤ");
				return 0;
			}
		}
		/*  ޷  */
		if (a->TraceData[2].code == 1 ) {
			if (TrimC_Line(*a, &PointX, &PointY, 2) == 0) {
				printf("Split-21 : error : ޤ");
				return 0;
			}
		}
		/*  ޷ ߸̤ޤϱ */
		if (a->TraceData[2].code == 2 || a->TraceData[2].code == 4) {
			if (TrimC_AC(*a, &PointX, &PointY, 2) == 0) {
				printf("Split-22 : error : ޤ");
				return 0;
			}
		}

		/* -------------------------------------------------
		 * å
		 */
		if ( (sg(PointX, compa_digits) == sg(a->TraceData[1].sx, compa_digits) && sg(PointY, compa_digits) == sg(a->TraceData[1].sy, compa_digits)) 
			|| (sg(PointX, compa_digits) == sg(a->TraceData[1].ex, compa_digits) && sg(PointY, compa_digits) == sg(a->TraceData[1].ey, compa_digits)))
		{
			if (sg(PointX, compa_digits) == sg(a->TraceData[1].sx, compa_digits) && sg(PointY, compa_digits) == sg(a->TraceData[1].sy, compa_digits))
				printf("Split : error : ʬƱǤLINE");
			else if (sg(PointX, compa_digits) == sg(a->TraceData[1].ex, compa_digits) && sg(PointY, compa_digits) == sg(a->TraceData[1].ey, compa_digits))
				printf("Split : error : ʬƱǤLINE");
			return 0;
		}

		/* -------------------------------------------------
		 * ߸ʬ¹
		 *  ( PointX , PointY )
		 */
		/* ߸̤ SA & EA  */
		SA = Arc_SE_Angle(a->TraceData[1], 0);
		EA = Arc_SE_Angle(a->TraceData[1], 1);

		/* 濴ޤǤγ PA 롣 */
		LAH.sx[1] = a->TraceData[1].cx;
		LAH.sy[1] = a->TraceData[1].cy;
		LAH.ex[1] = PointX;
		LAH.ey[1] = PointY;
		la(&LAH);
		PA = sg(LAH.angle, calcu_digits);

		/* ߸̤αĹ -------------------------------------- */
		if (((SA < EA) && (PA < SA || PA > EA)) || ((SA > EA) && (PA < SA && PA > EA))) {
			return 0; /* Beep; */
		}

		/* ߸̤ʬ -------------------------------------- */
		/* (PointX,PointY) */
		/* ʬ䤷ƤǤǡ*/
		a->TraceData[3].code = 2;
		a->TraceData[3].layer = a->TraceData[1].layer;
		a->TraceData[3].style = a->TraceData[1].style;
		a->TraceData[3].color = a->TraceData[1].color;
		a->TraceData[3].cx = a->TraceData[1].cx;
		a->TraceData[3].cy = a->TraceData[1].cy;
		a->TraceData[3].r = a->TraceData[1].r;
		a->TraceData[3].sx = sg(PointX, calcu_digits);
		a->TraceData[3].sy = sg(PointY, calcu_digits);
		a->TraceData[3].ex = a->TraceData[1].ex;
		a->TraceData[3].ey = a->TraceData[1].ey;
		/* Υǡ*/
		a->TraceData[1].ex = sg(PointX, calcu_digits);
		a->TraceData[1].ey = sg(PointY, calcu_digits);
		return 1;
	}
	return 0;
}





/* -------------------------------------------------------------------
 * եå
 * Fillet
 * struct TrimDat *		double R
 * int	  a->TraceData[3] : Fillet޷
 *		  ERR : 0	 OK : 1
 */
int Fillet(struct TrimDat *a, double R)
{
//#define FIRET_TEST
//char dumystr[256];


	CAD DumyCad;
	double DumyDbl1, DumyDbl2, CrossPointX = 0, CrossPointY = 0;
	double DumySX = 0, DumySY = 0, DumyEX = 0, DumyEY = 0, DumySX2 = 0, DumySY2 = 0, DumyEX2 = 0, DumyEY2 = 0;
	double FilletCX = 0, FilletCY = 0, DumyCX[3], DumyCY[3], L1, L2;
	int FilletType = 0, Int1 = 0, Int2 = 0;
	struct RtnDat DumyRTN;
	struct TrimDat DumyTrim;


	/* -----------------------------------------------------
	 * ޷ǤȽ
	 * 
	 */
	if (a->TraceData[1].code == 1 ) {
		/* <> (FilletType = 1) */
		if (a->TraceData[2].code == 1 ) {
			FilletType = 1;
		}
		/* <ȱ> (FilletType = 2) */
		else if (a->TraceData[2].code == 2 || a->TraceData[2].code == 4 ) {
			FilletType = 2;
		}
	}
	else if (a->TraceData[1].code == 2 || a->TraceData[1].code == 4 ) {
		/* <ߤ> (FilletType = 2) */
		if (a->TraceData[2].code == 1 ) {
			/* ǡ1  ǡ2 줫 */
			DumyCad = a->TraceData[1];
			DumyDbl1 = a->PicX[1];
			DumyDbl2 = a->PicY[1];
			a->TraceData[1] = a->TraceData[2];
			a->PicX[1] = a->PicX[2];
			a->PicY[1] = a->PicY[2];
			a->TraceData[2] = DumyCad;
			a->PicX[2] = DumyDbl1;
			a->PicY[2] = DumyDbl2;
			FilletType = 2;
		}
		/* <ߤȱ>  (FilletType = 3)*/
		else if (a->TraceData[2].code == 2 || a->TraceData[2].code == 4 ) {
			FilletType = 3;
		}
	}



	/* -----------------------------------------------------
	 * (ȥΤ)
	 * 
	 */
	if (FilletType == 1 ) {
		DumyRTN.sx[1] = a->TraceData[1].sx;
		DumyRTN.sy[1] = a->TraceData[1].sy;
		DumyRTN.ex[1] = a->TraceData[1].ex;
		DumyRTN.ey[1] = a->TraceData[1].ey;
		DumyRTN.sx[2] = a->TraceData[2].sx;
		DumyRTN.sy[2] = a->TraceData[2].sy;
		DumyRTN.ex[2] = a->TraceData[2].ex;
		DumyRTN.ey[2] = a->TraceData[2].ey;
		llp(&DumyRTN);

		/*  */
		CrossPointX = DumyRTN.sx[3];
		CrossPointY = DumyRTN.sy[3];
	}

	else if (FilletType == 2 ) {
		DumyRTN.sx[1] = a->TraceData[1].sx;
		DumyRTN.sy[1] = a->TraceData[1].sy;
		DumyRTN.ex[1] = a->TraceData[1].ex;
		DumyRTN.ey[1] = a->TraceData[1].ey;
		DumyRTN.cx[1] = a->TraceData[2].cx;
		DumyRTN.cy[1] = a->TraceData[2].cy;
		DumyRTN.r[1] = a->TraceData[2].r;
		DumyRTN.sx[4] = a->PicX[1];
		DumyRTN.sy[4] = a->PicY[1];
		DumyRTN.ex[4] = a->PicX[2];
		DumyRTN.ey[4] = a->PicY[2];
		LCP1(&DumyRTN);

		if (DumyRTN.type == 1) {
			CrossPointX = DumyRTN.sx[2];
			CrossPointY = DumyRTN.sy[2];
		}
		else if (DumyRTN.type == 0) {
			DumyRTN.sx[1] = a->TraceData[1].sx;
			DumyRTN.sy[1] = a->TraceData[1].sy;
			DumyRTN.ex[1] = a->TraceData[1].ex;
			DumyRTN.ey[1] = a->TraceData[1].ey;
			DumyRTN.sx[2] = a->TraceData[2].cx;
			DumyRTN.sy[2] = a->TraceData[2].cy;
			plp(&DumyRTN);
			
			/*  */
			CrossPointX = DumyRTN.ex[2];
			CrossPointY = DumyRTN.ey[2];
		}
	}

	else if (FilletType == 3) {
		DumyRTN.cx[1] = a->TraceData[1].cx;
		DumyRTN.cy[1] = a->TraceData[1].cy;
		DumyRTN.r[1] = a->TraceData[1].r;
		DumyRTN.cx[2] = a->TraceData[2].cx;
		DumyRTN.cy[2] = a->TraceData[2].cy;
		DumyRTN.r[2] = a->TraceData[2].r;
		DumyRTN.sx[1] = a->PicX[1];
		DumyRTN.sy[1] = a->PicY[1];
		DumyRTN.sx[2] = a->PicX[2];
		DumyRTN.sy[2] = a->PicY[2];
		CCP1(&DumyRTN);

		if (DumyRTN.type == 1) {
			/*  */
			CrossPointX = DumyRTN.sx[1];
			CrossPointY = DumyRTN.sy[1];
		}
		else if (DumyRTN.type == 0) {
			/*	*/
			DumyRTN.sx[1] = a->TraceData[1].cx;
			DumyRTN.sy[1] = a->TraceData[1].cy;
			DumyRTN.ex[1] = a->TraceData[2].cx;
			DumyRTN.ey[1] = a->TraceData[2].cy;
			pp(&DumyRTN);
			DumyDbl1 = DumyRTN.l;
			/*	*/
			DumyRTN.sx[1] = a->TraceData[1].cx;
			DumyRTN.sy[1] = a->TraceData[1].cy;
			DumyRTN.ex[1] = a->TraceData[2].cx;
			DumyRTN.ey[1] = a->TraceData[2].cy;
			la(&DumyRTN);
			DumyDbl2 = DumyRTN.angle;
			/*	*/
			DumyDbl1 = a->TraceData[1].r + (DumyDbl1 - a->TraceData[1].r - a->TraceData[2].r) / 2;
			/*	*/
			DumyRTN.sx[1] = a->TraceData[1].cx;
			DumyRTN.sy[1] = a->TraceData[1].cy;
			DumyRTN.angle = DumyDbl2;
			DumyRTN.l = DumyDbl1;
			pap(&DumyRTN);

			/*  */
			CrossPointX = DumyRTN.ex[1];
			CrossPointY = DumyRTN.ey[1];
		}
	}



	/* -----------------------------------------------------
	 * եå濴
	 * 
	 */
	/* <> (FilletType = 1) */
	if (FilletType == 1) {
		/* 1 ФФԥå2 Ϥɤä¦ */
		/* ľοʹαˤ뤫ˤ뤫
		 * ChkPointLineSide
		 * (a->sx[1], a->sy[1]) - (a->ex[1], a->ey[1]),,(a->sx[2], a->sy[2])
		 * 	a->type = 0ERR	1	2	3
		 */
		DumyRTN.sx[1] = a->TraceData[1].sx;
		DumyRTN.sy[1] = a->TraceData[1].sy;
		DumyRTN.ex[1] = a->TraceData[1].ex;
		DumyRTN.ey[1] = a->TraceData[1].ey;
		DumyRTN.sx[2] = a->PicX[2];
		DumyRTN.sy[2] = a->PicY[2];
		ChkPointLineSide(&DumyRTN);
		Int1 = DumyRTN.type;
		
		/* 2 ФФԥå1 Ϥɤä¦ */
		DumyRTN.sx[1] = a->TraceData[2].sx;
		DumyRTN.sy[1] = a->TraceData[2].sy;
		DumyRTN.ex[1] = a->TraceData[2].ex;
		DumyRTN.ey[1] = a->TraceData[2].ey;
		DumyRTN.sx[2] = a->PicX[1];
		DumyRTN.sy[2] = a->PicY[1];
		ChkPointLineSide(&DumyRTN);
		Int2 = DumyRTN.type;

#ifdef FIRET_TEST /* --------------------------------------------------- */
		if(Int1==1)	sprintf(dumystr,"1ФФԥå2ϡ");
		else if(Int1==2)	sprintf(dumystr,"1ФФԥå2ϡ");
		else if(Int1==3)	sprintf(dumystr,"1ФФԥå2ϡ");
		else if(Int1==0)	sprintf(dumystr,"1ФФԥå2ϡerr");
		MsgBox("FIRET TEST Test", dumystr);
		if(Int2==1)	sprintf(dumystr,"2ФФԥå1ϡ");
		else if(Int2==2)	sprintf(dumystr,"2ФФԥå1ϡ");
		else if(Int2==3)	sprintf(dumystr,"2ФФԥå1ϡ");
		else if(Int2==0)	sprintf(dumystr,"2ФФԥå1ϡerr");
		MsgBox("FIRET TEST Test", dumystr);
		sprintf(dumystr,"ԥå1 (%f,%f)    ԥå2 (%f,%f)", 
						a->PicX[1], a->PicY[1], a->PicX[2], a->PicY[2]);
		MsgBox("FIRET TEST Test", dumystr);
#endif /* -------------------------------------------------------------- */


		/* 1ԥå2˥եå */
		/* ------------------------------------------------ */
		/* LO	ȽͿľΥեå */
		/* ------------------------------------------------ */
		DumyRTN.sx[1] = a->TraceData[1].sx;
		DumyRTN.sy[1] = a->TraceData[1].sy;
		DumyRTN.ex[1] = a->TraceData[1].ex;
		DumyRTN.ey[1] = a->TraceData[1].ey;
		DumyRTN.l = R;
		lo(&DumyRTN);
		/*  */
		if (Int1 == 1) {
			DumySX = DumyRTN.sx[3];
			DumySY = DumyRTN.sy[3];
			DumyEX = DumyRTN.ex[3];
			DumyEY = DumyRTN.ey[3];
		}
		/*  */
		else if (Int1 == 2) {
			DumySX = DumyRTN.sx[2];
			DumySY = DumyRTN.sy[2];
			DumyEX = DumyRTN.ex[2];
			DumyEY = DumyRTN.ey[2];
		}
		
		/* 2ԥå1˥եå */
		DumyRTN.sx[1] = a->TraceData[2].sx;
		DumyRTN.sy[1] = a->TraceData[2].sy;
		DumyRTN.ex[1] = a->TraceData[2].ex;
		DumyRTN.ey[1] = a->TraceData[2].ey;
		DumyRTN.l = R;
		lo(&DumyRTN);
		/*  */
		if (Int2 == 1) {
			DumySX2 = DumyRTN.sx[3];
			DumySY2 = DumyRTN.sy[3];
			DumyEX2 = DumyRTN.ex[3];
			DumyEY2 = DumyRTN.ey[3];
		}
		/*  */
		else if (Int2 == 2) {
			DumySX2 = DumyRTN.sx[2];
			DumySY2 = DumyRTN.sy[2];
			DumyEX2 = DumyRTN.ex[2];
			DumyEY2 = DumyRTN.ey[2];
		}


		/* 1ԥå2˥եåȤ */
		/* 2ԥå1˥եåȤθ */
		/* ------------------------------------------------ */
		/* LLP	ľθ  ƤΥեå P120 */
		/* ------------------------------------------------ */
		DumyRTN.sx[1] = DumySX;
		DumyRTN.sy[1] = DumySY;
		DumyRTN.ex[1] = DumyEX;
		DumyRTN.ey[1] = DumyEY;
		DumyRTN.sx[2] = DumySX2;
		DumyRTN.sy[2] = DumySY2;
		DumyRTN.ex[2] = DumyEX2;
		DumyRTN.ey[2] = DumyEY2;
		llp(&DumyRTN);

		if (DumyRTN.type == 0) {
			printf("Fillet : error : ޤ(ľʿ)");
			return 0;
		}

		/* եå濴	DumyRTN.SX[3]	DumyRTN.SY[3] */
		FilletCX = DumyRTN.sx[3];
		FilletCY = DumyRTN.sy[3];
		
	}





	/* <ȱ> (FilletType = 2) */
	else if (FilletType == 2) {
		/* 1ФФԥå2Ϥɤä¦ */
		/* ľοʹαˤ뤫ˤ뤫
		 * ChkPointLineSide
		 * (a->sx[1], a->sy[1]) - (a->ex[1], a->ey[1]),,(a->sx[2], a->sy[2])
		 * 	a->type = 0ERR	1	2	3
		 */
		DumyRTN.sx[1] = a->TraceData[1].sx;
		DumyRTN.sy[1] = a->TraceData[1].sy;
		DumyRTN.ex[1] = a->TraceData[1].ex;
		DumyRTN.ey[1] = a->TraceData[1].ey;
		DumyRTN.sx[2] = a->PicX[2];
		DumyRTN.sy[2] = a->PicY[2];
		ChkPointLineSide(&DumyRTN);
		Int1 = DumyRTN.type;
		
		/* 2ФФԥå1Ϥɤä¦ */
		/* ߤˤ뤫ˤ뤫
		 * ChkPointCircleSide
		 * (a->sx[1] , a->sy[1])	(a->cx[1] , a->cy[1]) , a->r[1]
		 *	a->type = 0ERR   1   2   3
		 */
		DumyRTN.cx[1] = a->TraceData[2].cx;
		DumyRTN.cy[1] = a->TraceData[2].cy;
		DumyRTN.r[1] = a->TraceData[2].r;
		DumyRTN.sx[1] = a->PicX[1];
		DumyRTN.sy[1] = a->PicY[1];
		ChkPointCircleSide(&DumyRTN);
		Int2 = DumyRTN.type;


#ifdef FIRET_TEST /* --------------------------------------------------- */
		if(Int1==1)	sprintf(dumystr,"1ФФԥå2ϡ");
		else if(Int1==2)	sprintf(dumystr,"1ФФԥå2ϡ");
		else if(Int1==3)	sprintf(dumystr,"1ФФԥå2ϡ");
		else if(Int1==0)	sprintf(dumystr,"1ФФԥå2ϡerr");
		MsgBox("FIRET TEST Test", dumystr);
		if(Int2==1)	sprintf(dumystr,"2ФФԥå1ϡ");
		else if(Int2==2)	sprintf(dumystr,"2ФФԥå1ϡ");
		else if(Int2==3)	sprintf(dumystr,"2ФФԥå1ϡ");
		else if(Int2==0)	sprintf(dumystr,"2ФФԥå1ϡerr");
		MsgBox("FIRET TEST Test", dumystr);
		sprintf(dumystr,"ԥå1 (%f,%f)    ԥå2 (%f,%f)", 
						a->PicX[1], a->PicY[1], a->PicX[2], a->PicY[2]);
		MsgBox("FIRET TEST Test", dumystr);
#endif /* -------------------------------------------------------------- */


		DumyRTN.sx[1] = a->TraceData[1].sx;
		DumyRTN.sy[1] = a->TraceData[1].sy;
		DumyRTN.ex[1] = a->TraceData[1].ex;
		DumyRTN.ey[1] = a->TraceData[1].ey;
		DumyRTN.l = R;
		lo(&DumyRTN);
		/*  */
		if (Int1 == 1) {
			DumyRTN.sx[1] = DumyRTN.sx[3];
			DumyRTN.sy[1] = DumyRTN.sy[3];
			DumyRTN.ex[1] = DumyRTN.ex[3];
			DumyRTN.ey[1] = DumyRTN.ey[3];
		}
		/*  */
		else if (Int1 == 2) {
			DumyRTN.sx[1] = DumyRTN.sx[2];
			DumyRTN.sy[1] = DumyRTN.sy[2];
			DumyRTN.ex[1] = DumyRTN.ex[2];
			DumyRTN.ey[1] = DumyRTN.ey[2];
		}


		/*  */
		if (Int2 == 1) {
			DumyRTN.cx[1] = a->TraceData[2].cx;
			DumyRTN.cy[1] = a->TraceData[2].cy;
			DumyRTN.r[1] = a->TraceData[2].r - R;
		}
		/*  */
		else if (Int2 == 2) {
			DumyRTN.cx[1] = a->TraceData[2].cx;
			DumyRTN.cy[1] = a->TraceData[2].cy;
			DumyRTN.r[1] = a->TraceData[2].r + R;
#ifdef FIRET_TEST /* --------------------------------------------------- */
//		CircleDraw(hDrawArea, DumyRTN.cx[1], DumyRTN.cy[1], DumyRTN.r[1], 1, 0x00ffffff);
#endif // --------------------------------------------------------------
		}
		/* ľȱߤθ  ƤΥեå P126 */
		lcp(&DumyRTN);

		if (DumyRTN.type == 0) {
			printf("Fillet : error : ޤ(Ҥ)");
			return 0;
		}

		/* 1  ( DumyRTN.SX[2] , DumyRTN.SX[2] ) */
		/* 2  ( DumyRTN.SX[3] , DumyRTN.SX[3] ) */
		DumyCX[1] = DumyRTN.sx[2];
		DumyCY[1] = DumyRTN.sy[2];
		DumyCX[2] = DumyRTN.sx[3];
		DumyCY[2] = DumyRTN.sy[3];
	}





	/* <ߤȱ> (FilletType = 3) */
	else if (FilletType == 3) {
		/* 1ФФԥå2Ϥɤä¦ */
		DumyRTN.cx[1] = a->TraceData[1].cx;
		DumyRTN.cy[1] = a->TraceData[1].cy;
		DumyRTN.r[1] = a->TraceData[1].r;
		DumyRTN.sx[1] = a->PicX[2];
		DumyRTN.sy[1] = a->PicY[2];
		ChkPointCircleSide(&DumyRTN);
		Int1 = DumyRTN.type;

		/* 2ФФԥå1Ϥɤä¦ */
		DumyRTN.cx[1] = a->TraceData[2].cx;
		DumyRTN.cy[1] = a->TraceData[2].cy;
		DumyRTN.r[1] = a->TraceData[2].r;
		DumyRTN.sx[1] = a->PicX[1];
		DumyRTN.sy[1] = a->PicY[1];
		ChkPointCircleSide(&DumyRTN);
		Int2 = DumyRTN.type;
		
		/* CCP	ߤθ */
		/*  */
		if (Int1 == 1) 	{
			DumyRTN.cx[1] = a->TraceData[1].cx;
			DumyRTN.cy[1] = a->TraceData[1].cy;
			DumyRTN.r[1] = a->TraceData[1].r - R;
		}
		/*  */
		else if (Int1 == 2) {
			DumyRTN.cx[1] = a->TraceData[1].cx;
			DumyRTN.cy[1] = a->TraceData[1].cy;
			DumyRTN.r[1] = a->TraceData[1].r + R;
		}


		/*  */
		if (Int2 == 1) {
			DumyRTN.cx[2] = a->TraceData[2].cx;
			DumyRTN.cy[2] = a->TraceData[2].cy;
			DumyRTN.r[2] = a->TraceData[2].r - R;
		}
		/*  */
		else if (Int2 == 2) {
			DumyRTN.cx[2] = a->TraceData[2].cx;
			DumyRTN.cy[2] = a->TraceData[2].cy;
			DumyRTN.r[2] = a->TraceData[2].r + R;
		}
		
		/* ߤθ */
		ccp(&DumyRTN);

		if (DumyRTN.type == 0) {
			printf("Fillet : error : ޤ(Ҥ)");
			return 0;
		}
		
		/* 1  ( DumyRTN.SX[1] , DumyRTN.SX[1] ) */
		/* 2  ( DumyRTN.SX[2] , DumyRTN.SX[2] ) */
		DumyCX[1] = DumyRTN.sx[1];
		DumyCY[1] = DumyRTN.sy[1];
		DumyCX[2] = DumyRTN.sx[2];
		DumyCY[2] = DumyRTN.sy[2];
	}





	/* ----------------------------------------------------- */
	/* եåȱߤ濴ԥå˶ᤤȤ롣--------- */
	/* ᤤۤǤϤʤ [濴ԥåγ]	*/
	/*  [濴γ] */
	/* Ƚ̤褤ΤǤϡ */
	/*	*/
	/*	*/
	/*	*/
	if (FilletType == 2 || FilletType == 3)
	{
		/* ------------------------------------------------ */
		/* PP	֤εΥ */
		/* ------------------------------------------------ */
		/* L1 */
		DumyRTN.sx[1] = DumyCX[1];
		DumyRTN.sy[1] = DumyCY[1];
		DumyRTN.ex[1] = a->PicX[1];
		DumyRTN.ey[1] = a->PicY[1];
		pp(&DumyRTN);
		L1 = DumyRTN.l;

		DumyRTN.sx[1] = DumyCX[1];
		DumyRTN.sy[1] = DumyCY[1];
		DumyRTN.ex[1] = a->PicX[2];
		DumyRTN.ey[1] = a->PicY[2];
		pp(&DumyRTN);
		L1 = L1 + DumyRTN.l;

		/* L2 */
		DumyRTN.sx[1] = DumyCX[2];
		DumyRTN.sy[1] = DumyCY[2];
		DumyRTN.ex[1] = a->PicX[1];
		DumyRTN.ey[1] = a->PicY[1];
		pp(&DumyRTN);
		L2 = DumyRTN.l;

		DumyRTN.sx[1] = DumyCX[2];
		DumyRTN.sy[1] = DumyCY[2];
		DumyRTN.ex[1] = a->PicX[2];
		DumyRTN.ey[1] = a->PicY[2];
		pp(&DumyRTN);
		L2 = L2 + DumyRTN.l;

		if (L1 < L2) {
			FilletCX = DumyCX[1];
			FilletCY = DumyCY[1];
		}
		else if (L1 > L2) {
			FilletCX = DumyCX[2];
			FilletCY = DumyCY[2];
		}
	}
	/* ----- < եåȱߤ濴ԥå˶ᤤȤ롣> ------------------ */





	/* ----------------------------------------------------- */
	/* եåȱߤ CAD ǡˤ --------------------- */
	a->TraceData[3].code = 4;
	a->TraceData[3].layer = a->TraceData[1].layer;//NowLayer;
	a->TraceData[3].style = a->TraceData[1].style;//NowStyle;
	a->TraceData[3].color = a->TraceData[1].color;//NowColor;
	
	a->TraceData[3].cx = sg(FilletCX, calcu_digits);
	a->TraceData[3].cy = sg(FilletCY, calcu_digits);
	a->TraceData[3].r = R;


	/* ----------------------------------------------------- */
	/* եåȱߤȥह ---------------------------- */

	/* ȥΤȤΥԥå */
	/* LA	ľγ */
	DumyRTN.sx[1] = a->TraceData[3].cx;
	DumyRTN.sy[1] = a->TraceData[3].cy;
	DumyRTN.ex[1] = CrossPointX;
	DumyRTN.ey[1] = CrossPointY;
	la(&DumyRTN);
	
	/* PAP	ȳ٤ȵΥľν */
	DumyRTN.l = a->TraceData[3].r;
	pap(&DumyRTN);
	
	CrossPointX = DumyRTN.ex[1];
	CrossPointY = DumyRTN.ey[1];

	/* ----------------------------------------------------- */
	/* ȥ޷ߤʤȥ¹ ------------------------ */
	DumyTrim.TraceData[1] = a->TraceData[3];
	DumyTrim.PicX[1] = CrossPointX;
	DumyTrim.PicY[1] = CrossPointY;
	
	DumyTrim.TraceData[2] = a->TraceData[1];
	DumyTrim.PicX[2] = a->PicX[1];
	DumyTrim.PicY[2] = a->PicY[1];
	
	DumyTrim.TraceData[3] = a->TraceData[2];
	DumyTrim.PicX[3] = a->PicX[2];
	DumyTrim.PicY[3] = a->PicY[2];
	
	DumyTrim.Index = 2;

	/* < ȥ¹ > */
	TrimMain(&DumyTrim);

	a->TraceData[1] = DumyTrim.TraceData[2];
	a->PicX[1] = DumyTrim.PicX[2];
	a->PicY[1] = DumyTrim.PicY[2];
	
	a->TraceData[2] = DumyTrim.TraceData[3];
	a->PicX[2] = DumyTrim.PicX[3];
	a->PicY[2] = DumyTrim.PicY[3];
	
	a->TraceData[3] = DumyTrim.TraceData[1];
	a->PicX[3] = DumyTrim.PicX[1];
	a->PicY[3] = DumyTrim.PicY[1];
	return 1;
}





/* ============================================================
 * == Copyright (C) 2001 Yutaka Sagiya. All rights reserved. ==
 * ============================================================
 *	  Project			   : SagCAD
 *	  Source			   : TrimFunc.c
 * ============================================================
 */
