/* ====================================================================
 * ===  Copyright (C) 1998-2002 Yutaka Sagiya. All rights reserved. ===
 * ====================================================================
 * 
 *    Project              : SagCAD
 *    Description          : CAD/CAM
 *    Source               : etc.c
 * 
 *    ----------------------------------
 * 
 *    Copyright            : (C) 1998-2002 by Yutaka Sagiya
 *    email                : kappa@a6s.highway.ne.jp
 *                         : yutaka@sagiya.com
 *    Begin                : 2001/01/16
 *    Last                 : 2003/02/05
 * ====================================================================
 */

#ifdef WIN32
#include <windows.h>
#endif

#ifdef LINUX
#include <gtk/gtk.h>
#include <unistd.h>
#include <pwd.h>
#include <sys/types.h>
#include <sys/stat.h>
#endif

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "ver.h"
#include "MemoryLeak.h"
#include "List_cad.h"
#include "List_Dimension.h"
#include "List_PolyLine.h"
#include "List_Block.h"
#include "List_Undo.h"
#include "List_Select.h"
#include "List_font.h"
#define _ETC_
#include "etc.h"





/* -------------------------------------------------------------------
 * ʸ str  nܤˤ split_word ΰ֤֤
 *	
 * "פ˰Ϥޤ줿,Ͽʤ
 *	
 */
int split_word_point(char *str, char split_word, int n)
{
	int point = 1;
	int counter = 0;
	int i;

	i = 0;
	while (*str) {
		if (*str == '\"' && i == 1)	i = 0;
		else if (*str == '\"' && i == 0)	i = 1;

		if (*str == split_word && i == 0) {
			counter++;
			if (n == counter) {
				return(point);
			}
		}
		point++;
		str++;
	}
	return 0;
}



/* -------------------------------------------------------------------
 * ʸ str  split_word Ĥ뤫֤
 *	
 * "פ˰Ϥޤ줿,Ͽʤ
 *	
 */
int split_word_num(char *str, char split_word)
{
	int counter = 0;
	int i;

	i = 0;
	while (*str) {
		if (*str == '\"' && i == 1)	i = 0;
		else if (*str == '\"' && i == 0)	i = 1;
		
		if (*str == split_word && i == 0) {
			counter++;
		}
		str++;
	}
	return(counter);
}



/* -------------------------------------------------------------------
 * ʸ str κ num ʸФʸ ret ֤
 *	
 * "פ˰Ϥޤ줿,Ͽʤ
 *	
 */
int strLeft(char *str, int num, char *ret)
{
	int counter = 1;
	if ((int) strlen(str) < num)	return(0);

	while (counter <= num) {
		*ret = *str;
		counter++;
		str++;
		ret++;
	}
	*ret = '\0';
	return(1);
}



/* -------------------------------------------------------------------
 * ʸ str κ midܤ numʸФ
 * ʸ ret ֤
 *	
 * "פ˰Ϥޤ줿,Ͽʤ
 *	
 */
int strMid(char *str, int mid, int num, char *ret)
{
	int counter = 1;
	if ((int)strlen(str) < mid)	return(-1 * ((int)strlen(str)));
	
	str = str + (mid - 1);
	while (*str) {
		if (*str == '\0')	return (-1);
		*ret = *str;
		counter++;
		str++;
		ret++;
		if (counter > num) {
			*ret = '\0';
			return(1);
		}
	}
	*ret = '\0';
	return(-1);
}



/* -------------------------------------------------------------------
 * ʸ str α num ʸФʸ ret ֤
 *	
 * "פ˰Ϥޤ줿,Ͽʤ
 *	
 */
int strRight(char *str, int num, char *ret)
{
	if ((int)strlen(str) < num)	return(0);
	str = str + (strlen(str) - num);
	while (*str) {
		*ret = *str;
		str++;
		ret++;
	}
	*ret = '\0';
	return(1);
}



/* -------------------------------------------------------------------
 * ץåʸ (split_word) Ƕڤơǡ¤Ǥʸ (str) 
 * num ܤΥǡʸФʸ (ret) ֤
 *	
 * 1,2,3,4,5,6,7
 *	1 2 3 4 5 6
 * 1234567890123
 *	
 *	
 * "פ˰Ϥޤ줿,Ͽʤ
 *	
 */
int LineDataSplit(char *str, char split_word, int num, char *ret)
{
	char DumyStr[256], StrStr[256];
	int Len, Split, Split_P[2];

	/* ʸ str  split_word Ĥ뤫֤ */
	Split = split_word_num(str, split_word);
	if (num	 > Split + 1 )	return -1;

	if (num == 1) {
		/* ʸ str  nܤˤ split_word ΰ֤֤ */
		Split_P[0] = split_word_point(str, split_word, 1);
		/* ʸ str κ num ʸФʸ ret ֤ */
		strLeft(str, Split_P[0] - 1, DumyStr);
	}
	else if (num > 1 && num <= Split) {
		/* ʸ str  nܤˤ split_word ΰ֤֤ */
		Split_P[0] = split_word_point(str, split_word, num - 1);
		Split_P[1] = split_word_point(str, split_word, num);
		strMid(str, Split_P[0] + 1, Split_P[1] - Split_P[0] - 1, DumyStr);
	}
	else if (num == Split + 1) {
		/* ʸ str  nܤˤ split_word ΰ֤֤ */
		Split_P[0] = split_word_point(str, split_word, num - 1);
		/* ʸ str α num ʸФʸ ret ֤ */
		strRight(str, strlen(str) - Split_P[0], DumyStr);
	}

	Len = strlen(DumyStr);
	if (DumyStr[0] == '\"' && DumyStr[Len - 1] == '\"') {
		if(Len > 2) {
			strMid(DumyStr, 2, Len - 2, StrStr);
			strcpy(ret, StrStr);
			return Split;
		}
		else {
			strcpy(ret, "");
			return Split;
		}
	}
	else {
		strcpy(ret, DumyStr);
		return Split;
	}
}



/* -------------------------------------------------------------------
 * ֤ؿ
 * 
 */
void replace(char *text, char *key, char *rep)
{
	char *p, work[2*256], a[2*256];

	strcpy(work, text);
	p = search(work, key);				/*	ΰ˥ԡ*/
	while (p != NULL) {
		if (strlen(work) > (256*2)-1) {
			work[2*256-2] = '\n';
			work[2*256-1] = '\0';
			break;
		}
		*p = '\0';
		strcpy(a, p + strlen(key)); 	/* ʸƤȥХåե˥ԡ */
		strcat(work, rep);				/* ֤ʸworkϢ뤹 */
		strcat(work, a);				/* ΰ֤õ */
		p = search(p+strlen(rep), key);
	}
	strcpy(text, work);
}



/* -------------------------------------------------------------------
 * ؿ
 *	
 */
char *search(char *text, char *key)
{
	int m, n;
	char *p;

	m = strlen(text);
	n = strlen(key);
	for (p = text ; p <= text + m - n ; p++) {
		if (strncmp(p, key, n) == 0)	/* 2ĤʸʸӤޤ */
			return (p);
	}
	return (NULL);
}



/* -------------------------------------------------------------------
 * ltrim
 *	
 */
int ltrim(char *str, char *ret)
{
	while (*str) {
		if (*str == ' ' || *str == '	' || *str == '\n' || *str == '\r') {
			str++;
		}
		else {
			*ret = *str;
			str++;
			ret++;
		}
	}
	*ret = '\0';
	return 1;
}



/* -------------------------------------------------------------------
 * եѥ̾ե̾
 *	
 * char *lpszPath	  ե̾ޤѥ̾ؤΥݥ
 * char * ե̾ؤΥݥ
 * ե̾ޤޤʤȤ""ؤΥݥ
 * [\],[/],[:]Ĥʤä硢ե̾ȤߤʤƤΤޤ֤
 *	
 * ѥ̾Ƭʸ򸡺ơ:,\,/פΤ줫Ǹ˸õ
 * ʸӤȤϡоݤʸ2Хʸ1ХʸĴ٤ɬפޤ
 *	
 * "פ˰Ϥޤ줿,Ͽʤ
 */
char *getFileName(char *lpszPath)
{
	char *lpszPtr = lpszPath;
	int charset = 0, Ret;
	int (*WHAT_KANJI)(/* unsigned */ char *str) = 0;


	Ret = Get_charset();
	if (Ret == 0) {
		charset = 2;
		WHAT_KANJI = whatKanji_sjis;
	}
	else if (Ret == 1) {
		charset = 8;
		WHAT_KANJI = whatKanji_euc;
	}

	while(*lpszPtr != '\0') {
		/* ХʸƬϥå */
		if((WHAT_KANJI((unsigned char *) lpszPtr) & charset) == charset ) {
			/* ʸ */
			lpszPtr++;
		}
		else {
			/* [\],[/],[:]򸫤Ĥ鸽+1Υݥ󥿤¸ */
			if((*lpszPtr == '\\') || (*lpszPtr == '/') || (*lpszPtr == ':')) {
				lpszPath=lpszPtr+1;
			}
		}
		/* ʸ */
		lpszPtr++;
	}
	return lpszPath;
}



/* -------------------------------------------------------------------
 * ե̾ĥҤ
 *	
 * char *lpszFileName	  ե̾ؤΥݥ
 * ʼ¹Ը塢ե̾ĥҤڤΥ
 */
void cutExtName(char *lpszFileName)
{
	char *pEnd = lpszFileName;
	char *pStart = lpszFileName;

	int charset = 0, Ret;
	int (*WHAT_KANJI)(/* unsigned */ char *str) = 0;


	Ret = Get_charset();
	if (Ret == 0) {
		charset = 2;
		WHAT_KANJI = whatKanji_sjis;
	}
	else if (Ret == 1) {
		charset = 8;
		WHAT_KANJI = whatKanji_euc;
	}


	/* ǥ쥯ȥʬκǸޤ */
	while(*pEnd != '\0') {
		/* ХʸƬϥå */
		if((WHAT_KANJI((unsigned char *) pEnd) & charset) == charset ) {
			/* ʸ */
			pEnd++;
		}
		else {
			/* [\],[/],[:]򸫤Ĥ鸽+1Υݥ󥿤¸ */
			if((*pEnd == '\\') || (*pEnd == '/') || (*pEnd == ':')) {
				pStart=pEnd+1;
			}
		}
		/* ʸ */
		pEnd++;
	}


	pEnd=lpszFileName;
	while(*pStart != '\0') {
		/* ХʸƬϥå */
		if((WHAT_KANJI((unsigned char *) pStart) & charset) == charset ) {
			/* ʸ */
			pStart++;
		}
		else {
			/* [.]򸫤Ĥ鸽+1Υݥ󥿤¸ */
			if(*pStart == '.') {
				pEnd=pStart;
			}
		}
		/* ʸ */
		pStart++;
	}


	/* ե̾˳ĥҤޤޤʤä粿⤷ʤ */
	if(pEnd == lpszFileName) {
		return;
	}
	/* ե̾ĥҤڤΥ */
	*pEnd='\0';
}



/* -------------------------------------------------------------------
 * ѥ̾ե̾
 *	
 * char *lpszPath	  ե̾ޤѥ̾ؤΥݥ
 * ʼ¹Ը塢ѥ̾ե̾ڤΥ
 *
 * ѥ̾Ƭʸ򸡺ơ:,\,/פΤ줫Ǹ˸줿Υݥ󥿤
 * '\0' 뤳Ȥǥե̾ޤ
 */
void cutFileName(char *lpszPath)
{
	char *lpszEnd = lpszPath;

	int charset = 0, Ret;
	int (*WHAT_KANJI)(/* unsigned */ char *str) = 0;


	Ret = Get_charset();
	if (Ret == 0) {
		charset = 2;
		WHAT_KANJI = whatKanji_sjis;
	}
	else if (Ret == 1) {
		charset = 8;
		WHAT_KANJI = whatKanji_euc;
	}


	while(*lpszPath != '\0') {
		/* ХʸƬϥå */
		if((WHAT_KANJI((unsigned char *) lpszPath) & charset) == charset ) {
			/* ʸ */
			lpszPath++;
		}
		else {
			/* [\],[/],[:]򸫤Ĥ鸽+1Υݥ󥿤¸ */
			if((*lpszPath == '\\') || (*lpszPath == '/') || (*lpszPath == ':')) {
				lpszEnd=lpszPath+1;
			}
		}
		/* ʸ */
		lpszPath++;
	}


	/* ѥ̾˥եޤޤʤä粿⤷ʤ */
	if(lpszEnd == lpszPath) {
		return;
	}
	/* ѥ̾ե̾ڤΥ */
	*lpszEnd='\0';
	return;
}



/* -------------------------------------------------------------------
 * ¹ԥեΥեѥ
 *	
 */
#ifdef AFTER
int GetAppPath(char *App_Path)
{
	char  szModulePath[MAX_PATH];


	/* ¹ԥեΥեѥ */
	GetModuleFileName(NULL, szModulePath, MAX_PATH);

	//ѥ̾ե̾
	//  char *lpszPath	ե̾ޤѥ̾ؤΥݥ
	//			  ʼ¹Ը塢ѥ̾ե̾ڤΥ
	//͡ʤ
	cutFileName(szModulePath);
	strcpy(App_Path, szModulePath);
	return 1;
}
#endif



/* -------------------------------------------------------------------
 * ȥ꡼फ飱ɤߤ ret ֤
 *	
 *	
 *	1 : Ԥ֤
 *	0 : ե뽪üˤ
 */
int LineRead(FILE *stream, char *ret)
{
	int i, j;
	char c, str[256];

	i = 0;
	j = 0;
	while((c = getc( stream )) != EOF) {
		/* CR ʳ */
		if (c == 0x0d) {
			// Ф
		}
		/* 1ɤ߹ߴλ */
		else if(c == 0x0a) {
			str[i] = '\0';
			strcpy(ret, str);
			return 1;
		}
		else {
			str[i] = (char)c;
			i++;
		}
		j++;
		if (j == 255) return -1;
	}
	return 0;
}



/* -------------------------------------------------------------------
 * RGB(0xrrggbb) Υ顼 (red, green, blue) Υǡʬ
 *	
 */
int color_split(struct ColorDat *a)
{
	int red, green, blue;

	/* blue */
	blue = a->rgb & 0x0000ff;
	a->blue = blue;
	/* green */
	green = a->rgb & 0x00ff00;
	green = green >> 8;
	a->green = green;
	/* red */
	red = a->rgb & 0xff0000;
	red = red >> 16;
	a->red = red;
	return 1;
}



/* ---------------------------------------------------------------------
 * (red, green, blue) Υǡ RGB(0xrrggbb) Υ顼˹
 *	
 */
long color_rgb(struct ColorDat *a)
{
	long red, green, blue;

	blue = a->blue;

	green = a->green;
	green = green << 8;

	red = a->red;
	red = red << 16;

	a->rgb = (red | green | blue);
	return (red | green | blue);
}



/* ---------------------------------------------------------------------
 * 0xrrggbb ηΥǡ "rr"  "bb" 򴹤
 * Windows(0xbbggrr) Υ顼  <-->  0xrrggbb  Ѵ
 *	
 */
long color_rb_change(long rgbcol)
{
	long color;
	long red, green, blue;

	/* red */
	red = rgbcol & 0x0000ff;
	red = red << 16;

	/* green */
	green = rgbcol & 0x00ff00;

	/* blue */
	blue = rgbcol & 0xff0000;
	blue = blue >> 16;

	color = red + green + blue;
	return color;
}



/* -------------------------------------------------------------------
 * ʸ(б 0xղ)ͤѴ
 *	
 */
int atoi16(char *str)
{
	char *hexstr;

	hexstr = strstr(str, "0x");
	if(hexstr != NULL) {
		hexstr = hexstr + 2;
		return hextoint(hexstr);
	}
	else return atoi(str);
}


/* -------------------------------------------------------------------
 * ʸͤѴ
 *	
 *  hextoint("B6119");
 */
int hextoint(char *str)
{
	int val;
	int sign;
	
	while (*str == ' ' || *str == '\t') str++;
	sign = 1;
	if (*str == '+') str++;
	else if (*str == '-') {
		sign = -1;
		str++;
	}
	val = 0;
	while ( (*str >= '0' && *str <= '9') ||
			(*str >= 'A' && *str <= 'F') ||
			(*str >= 'a' && *str <= 'f') ) {
		val <<= 4;
		if		(*str >= '0' && *str <= '9') val += *str - '0';
		else if (*str >= 'A' && *str <= 'F') val += *str - 'A' + 10;
		else								 val += *str - 'a' + 10;
		str++;
	}

	return sign == 1 ? val : -val;
}



/* -------------------------------------------------------------------
 * ʸ
 *	
 */
int HexString(long data, char *hex)
{
	int red, green, blue;
	char str[256];

	/* red */
	red = data & 0xff0000;
	red = red >> 16;
	/* green */
	green = data & 0x00ff00;
	green = green >> 8;
	/* blue */
	blue = data & 0x0000ff;

	sprintf(str, "%x", red);
	if (strlen(str) == 1) {
		sprintf(hex,"0x0%x", red);
	}
	else
		sprintf(hex,"0x%x", red);

	sprintf(str, "%x", green);
	if (strlen(str) == 1) {
		sprintf(str,"0%x", green);
	}
	else 
		sprintf(str,"%x", green);
	strcat(hex, str);

	sprintf(str, "%x", blue);
	if (strlen(str) == 1) {
		sprintf(str,"0%x", blue);
	}
	else 
		sprintf(str,"%x", blue);
	strcat(hex, str);
	return 1;
}


/* ===================================================================
 * ===	 Copyright (C) 2001 Yutaka Sagiya. All rights reserved.    ===
 * ===================================================================
 *	  Project			   : SagCAD
 *	  Description		   : CAD/CAM
 *	  Source			   : etc.c
 * ===================================================================
 */





/* -------------------------------------------------------------------
 * log ե񤭤
 *	
 */
int LogFileOpen(char *str)
{
	/* ե򥪡ץ */ 
	if((stream_log = fopen( str, "w")) == NULL) {
//		MsgBox("LogFileOpen", "ե %s ϳޤǤ");
		return 0;
	}
	LogFileWrite("SagCAD run\n");
	return 1;
}


int LogFileWrite(char *str)
{

	if (strstr(str, "\n") == NULL) strcat(str, "\n");
	fputs(str, stream_log);
	return 1;
}


int LogFileClose(void)
{
	LogFileWrite("SagCAD stop\n");
	/* ե򥯥 */ 
	fclose(stream_log);
	return 1;
}



/* -------------------------------------------------------------------
 * log ե񤭤
 *	
 */
int OneShotLog(char *str)
{
	FILE *stream;
	char path[256], dummy[256];


	GetConfigPath(path);

#ifdef WIN32
	sprintf(dummy, "%s\\OneShotLog", path);
#endif

#ifdef LINUX
	sprintf(dummy, "%s//OneShotLog", path);
#endif

	/* ե򥪡ץ */ 
	if((stream = fopen(dummy, "a")) == NULL) {
//		MsgBox("LogFileOpen", "ե %s ϳޤǤ");
		return 0;
	}

//	if (strstr(str, "\n") == NULL) strcat(str, "\n");
	fputs(str, stream);

	/* ե򥯥 */ 
	fclose(stream);
	return 1;
}


int DeleteOneShotLog(void)
{
	char path[256], str[256];


	GetConfigPath(path);

#ifdef WIN32
	sprintf(str, "%s\\OneShotLog", path);
	DeleteFile(str);
#endif

#ifdef LINUX
	sprintf(str, "%s//OneShotLog", path);
	unlink(str);
#endif

	return 0;
}





/* ====================================================================
 * ===  Copyright (C) 1998-2003 Yutaka Sagiya. All rights reserved. ===
 * ====================================================================
 *    Project              : SagCAD
 *    Source               : etc.c
 * ====================================================================
 */





/* -------------------------------------------------------------------
 * եΥѥ
 *	
 * Windows ξ硢¹ԥեƱեե֤
 * LINUX ξ硢/home/[user]/.sagcad/sagcadrc
 */
int GetConfigPath(char *path)
{
#ifdef WIN32
	/* ¹ԥեΥեѥ */
	GetModuleFileName(NULL, path, MAX_PATH);
	/* ѥ̾ե̾ */
	CutFileName(path);
	return 1;
#endif

#ifdef LINUX
	uid_t uid;
	struct passwd *pwd;

	uid = getuid();
	pwd = getpwuid(uid);
	sprintf(path, "%s/.sagcad", pwd->pw_dir);
	return 1;
#endif

	return 0;
}





/* -------------------------------------------------------------------
 * ɤμ 
 * 
 * եJISʤ0eucʤ1֤
 */
int Get_charset(void)
{
#ifdef WIN32
	return 0;
#endif

#ifdef LINUX
	char *envvalue, str[256];

	/* ja_JP.eucJP */
	envvalue = getenv("LANG");
	if (envvalue != NULL) {
		strcpy(str, envvalue);
		if (strstr(str, "euc") != NULL) {
			return 1;
		}
		else if (strstr(str, "EUC") != NULL) {
			return 1;
		}
		else if (strstr(str, "ujis") != NULL) {
			return 1;
		}
		else if (strstr(str, "SJIS") != NULL) {
			return 0;
		}
		else if (strstr(str, "sjis") != NULL) {
			return 0;
		}
		else if (strstr(str, "shift_jis") != NULL) {
			return 0;
		}
		else {
			return 1;
		}
		return 1;
	}
#endif
	return -1;
}





#ifdef LINUX
void home_of_user(char *home)
{
	uid_t uid;
	struct passwd *pwd;

	uid = getuid();
	pwd = getpwuid(uid);
	strcpy (home, pwd->pw_dir);
}





void name_of_user(char *user)
{
	uid_t uid;
	struct passwd *pwd;

	uid = getuid();
	pwd = getpwuid(uid);
	strcpy (user, pwd->pw_name);
}
#endif





