/* ====================================================================
 * ===  Copyright (C) 1998-2002 Yutaka Sagiya. All rights reserved. ===
 * ====================================================================
 * 
 *    Project              : sagcad
 *    Description          : CAD/CAM
 *    Source               : toolbar.c
 * 
 *    ----------------------------------
 * 
 *    Copyright            : (C) 1998-2002 by Yutaka Sagiya
 *    email                : kappa@a6s.highway.ne.jp
 *                         : yutaka@sagiya.com
 *    Begin                : 2001/01/16
 *    Last                 : 2002/06/25
 * ====================================================================
 */

#ifdef WIN32
#include <windows.h>
#endif

#ifdef LINUX
#include <gtk/gtk.h>
#include <unistd.h>
#include <pwd.h>
#include <sys/types.h>
#include <sys/stat.h>
#endif

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
//#include "Mouse.h"
//#include "etc.h"
//#include "Trace.h"
//#include "sagcad.h"

#include "ver.h"
#include "MemoryLeak.h"
#include "List_cad.h"
#include "List_Dimension.h"
#include "List_PolyLine.h"
#include "List_Block.h"
#include "List_Undo.h"
#include "List_Select.h"
#include "global.h"
#include "Command.h"
#define TOOLBAR
#include "toolbar.h"





/* -------------------------------------------------------------------
 * ġСκ  OutMode1  ()
 * 
 */
GtkWidget *create_toolbar_OutMode1(GtkWidget *window)
{
	/* ġС˺ܤܥ */
	struct ToolBarItem ToolBarItem_OutMode1[] = {
		{"",	New_xpm,		cmd_New,					0, 0},
		{"̤򳫤",	Open_xpm,		cmd_open,					0, 0},
		{"̾¸",	ReName_xpm,		cmd_rename,					0, 0},
		{"¸",		Save_xpm,		cmd_save,					0, 0},
		{"",	Parts_in_xpm,	cmd_parts_in,				0, 0},
		{"",		Print_xpm,		not_make/*cmd_print*/,		0, 0},
		{"",	PrinterSetting_xpm,	not_make/*cmd_out_data*/,0, 0},
		{"λ",		End_xpm,		cmd_end,					0, 0},
		{SPACE_CMD,		NULL,			NULL,						0, 0},
		{"ɥ",	Undo_xpm,		cmd_Undo,					0, 0},
		{"ɥ", 		Redo_xpm,		cmd_Redo,					0, 0},
		{SPACE_CMD,		NULL, 			NULL,						0, 0},
		{"å", 		Cut_xpm,		cmd_cut,					0, 0},
		{"ԡ", 		Copy_xpm,		cmd_copy,					0, 0},
		{"ڡ",	Paste_xpm,		cmd_paste,					0, 0},
		{SPACE_CMD,		NULL,			NULL,						0, 0},
		{"",		Redraw_xpm,		cmd_redraw,					0, 0},
		{"濴",	Center_xpm,		cmd_center,					0, 0},
		{"View 0   [ܥ : ] [ܥ : ¸]", View_0_xpm, cmd_view, 0, 1},
		{"View 1   [ܥ : ] [ܥ : ¸]", View_1_xpm, cmd_view, 0, 2},
		{"View 2   [ܥ : ] [ܥ : ¸]", View_2_xpm, cmd_view, 0, 3},
		{"View 3   [ܥ : ] [ܥ : ¸]", View_3_xpm, cmd_view, 0, 4},
		{"View 4   [ܥ : ] [ܥ : ¸]", View_4_xpm, cmd_view, 0, 5},
		{"View 5   [ܥ : ] [ܥ : ¸]", View_5_xpm, cmd_view, 0, 6},
		{SPACE_CMD,		NULL,			NULL,						0, 0},
		{"Ķ",	EnvSet_xpm,		cmd_env_set,				0, 0},
		{"С",	Version_xpm,	cmd_version,				0, 0},
		{"إ",		Help_xpm,		cmd_help,					0, 0},
		{NULL,			NULL,			NULL, 0, 0}
	};
	GtkWidget *toolbar;


	/* ġС */
	toolbar = gtk_toolbar_new(GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_ICONS);
	/* ġСĻ֤ */
	gtk_widget_show(GTK_WIDGET(toolbar));
	/* ġС˥ܥɲ */
	AppendButtons(window, toolbar, ToolBarItem_OutMode1);

	return toolbar;
}





/* -------------------------------------------------------------------
 * ġСκ  InMode1  (ķ)
 * 
 */
GtkWidget *create_toolbar_InMode1(GtkWidget *window)
{
	/* ġС˺ܤܥ */
	struct ToolBarItem ToolBarItem_InMode1[] = {
		{"",			Delete_xpm,			cmd_delete,						0, 0},
		{"",			Draw_xpm,			cmd_draw,						0, 0},
		{"ȥ",		Trim_xpm,			cmd_trim,						0, 0},
		{"եå",		Fillet_xpm,			cmd_fillet,						0, 0},
		{"ɸ",		Point_Input_xpm,	cmd_point,						0, 0},
		{"Ǳ",		Point3_xpm,			cmd_3point,						0, 0},
		{SPACE_CMD,			NULL,				NULL,							0, 0},
		{"쥯",		Select_xpm,			cmd_select,						0, 0},
		{"о",			Mirr_xpm,			cmd_mirr,						0, 0},
		{"ž",			Roll_xpm,			cmd_turn,						0, 0},
		{"",	Scaling_xpm,		cmd_scaling,					0, 0},
		{"쥤䡼ʣ",	LayerCopy_xpm,		cmd_layer_copy,					0, 0},
		{SPACE_CMD,			NULL,				NULL,							0, 0},
		{"ʿˡ",		DimenX_xpm,			cmd_x_dimension,				0, 0},
		{"Υˡ",		DimenDistance_xpm,	cmd_p_dimension,				0, 0},
		{"Ⱦˡ",		DimenR_xpm,			cmd_r_dimension,				0, 0},
		{"ɸˡ",		DimenPoint_xpm,		cmd_pt_dimension,				0, 0},
		{"",			DimenAtension_xpm,	cmd_at_dimension,				0, 0},
		{SPACE_CMD,			NULL,				NULL ,							0, 0},
		{"",			PolyLine_xpm,		cmd_polyline,					0, 0},
		{NULL,				NULL,				NULL,							0, 0}
	};
	GtkWidget *toolbar;


	/* ġС */
	toolbar = gtk_toolbar_new(GTK_ORIENTATION_VERTICAL, GTK_TOOLBAR_ICONS);
	/* ġСĻ֤ */
	gtk_widget_show(GTK_WIDGET(toolbar));
	/* ġС˥ܥɲ */
	AppendButtons(window, toolbar, ToolBarItem_InMode1);

	return toolbar;
}





/* -------------------------------------------------------------------
 * ġСκ  InMode2  (ķ)
 * 
 */
GtkWidget *create_toolbar_InMode2(GtkWidget *window)
{
	/* ġС˺ܤܥ */
	struct ToolBarItem ToolBarItem_InMode2[] = {
		{"󥻥",	Cancel_xpm,			cmd_all_cancel,						0, 0},
		{"ʬ",		Split_xpm,			cmd_split,							0, 0},
		{"ξȥ",	Both_Trim_xpm,		cmd_both_trim,						0, 0},
		{"̼",		C_Cut_xpm,			cmd_Chamfering,						0, 0},
		{"Ϣ³",		Cont_Line_xpm,		cmd_cont_line,						0, 0},
		{"դǱ",	Line3_xpm,			cmd_3line,							0, 0},
		{SPACE_CMD,		NULL,				NULL,								0, 0},
		{"ϰϥ쥯",RectSelect_xpm,		cmd_rect_select,					0, 0},
		{"ʿ",		Para_xpm,			cmd_parallel_copy,					0, 0},
		{"ʣ",	Matrix_xpm,			cmd_grid_copy,						0, 0},
		{"ѹ",	LineStyleChange_xpm,cmd_line_style_change,				0, 0},
		{"쥤䡼ư",LayerMove_xpm,		cmd_layer_move,						0, 0},
		{SPACE_CMD,		NULL,				NULL ,								0, 0},
		{"ľˡ",	DimenY_xpm,			cmd_y_dimension,					0, 0},
		{"ˡ",	DimenAngle_xpm,		cmd_a_dimension,					0, 0},
		{"ľˡ",	DimenD_xpm,			cmd_d_dimension,					0, 0},
		{"",		DimenPullLine_xpm,	cmd_hd_dimension,					0, 0},
		{"ˡԽ",	DimenEdit_xpm,		cmd_edt_dimension,					0, 0},
		{SPACE_CMD,		NULL,				NULL ,								0, 0},
		{"ʱ",		Ellipse_xpm,		not_make,							0, 0},
		{NULL,			NULL, 				NULL,								0, 0}
	};
	GtkWidget *toolbar;


	/* ġС */
	toolbar = gtk_toolbar_new(GTK_ORIENTATION_VERTICAL, GTK_TOOLBAR_ICONS);
	/* ġСĻ֤ */
	gtk_widget_show(GTK_WIDGET(toolbar));
	/* ġС˥ܥɲ */
	AppendButtons(window, toolbar, ToolBarItem_InMode2);

	return toolbar;
}





/* -------------------------------------------------------------------
 * pixmap widgwt 
 * 
 */
GtkWidget *pixmap_from_xpm(GtkWidget *widget, gchar **xpm_data)
{
	GdkBitmap *mask;
	GdkPixmap *pixmap_data;
	GtkWidget *pixmap_widget;


	pixmap_data = gdk_pixmap_create_from_xpm_d(MainWindow->window, 
											   &mask, 
											   &MainWindow->style->bg[GTK_STATE_NORMAL], 
											   (gchar **)xpm_data);
	pixmap_widget = gtk_pixmap_new(pixmap_data, mask);
	gtk_widget_show(pixmap_widget);

	return (pixmap_widget);
}





/* -------------------------------------------------------------------
 * ܥɲ
 * 
 */
void AppendButtons(GtkWidget *window, GtkWidget *toolbar, struct ToolBarItem *Item)
{
	GSList *group = NULL;
	GtkWidget *button;
	GtkWidget *gtkPixmap;
	GdkPixmap *gdkPixmap;
	GdkBitmap *gtkMask;


	/* ġСItem1Ȥ˥ܥɲ */
	while(Item->tooltips != NULL) {
		/* ڡɲá */
		if (strcmp(Item->tooltips, SPACE_CMD) == 0){
			/* ġС˷֤ */
			gtk_toolbar_append_space(GTK_TOOLBAR(toolbar));
			Item++;
			continue;
		}


		/* ԥåޥå(gdk) */
		gdkPixmap = gdk_pixmap_create_from_xpm_d(window->window,
												 &gtkMask,
												 &window->style->bg[GTK_STATE_NORMAL],
												 (gchar **)Item->xpm);
		/* ԥåޥå(gtk) */
		gtkPixmap = gtk_pixmap_new(gdkPixmap, gtkMask);


		/* -------------------------------------------------
		 * ̤Υܥ 
		 */
		if (Item->button_type == 0) {
			group = NULL;
			/* ܥ */
			button = gtk_button_new();
			
			/* ̤˺åΤߤǤȤ */
			if (Item->signal_type == 0) {
				/* "clicked"٥ȥϥɥ */
				gtk_signal_connect( GTK_OBJECT(button), "clicked",
									GTK_SIGNAL_FUNC(Item->func),
									NULL );
			}
			/* åȱå櫓Ȥ */
			else if (Item->signal_type != 0) {
				/* "button_press_event"٥ȥϥɥ */
				gtk_signal_connect( GTK_OBJECT(button), "button_press_event",
									GTK_SIGNAL_FUNC(Item->func),
									(gpointer)Item->signal_type);
			}
		}


		/* -------------------------------------------------
		 * 饸ܥ 
		 */
		else if (Item->button_type != 0) {
			
			/* ǽΥܥ */
			if (group == NULL) {
				/* 饸ܥ */
				button = gtk_radio_button_new(NULL);
				/* 饸ܥΥ롼פ */
				group = gtk_radio_button_group(GTK_RADIO_BUTTON(button));
				/* ܥONˤ */
				gtk_toggle_button_set_mode(GTK_TOGGLE_BUTTON(button), FALSE);
			}
			else {
				/* 饸ܥ */
				button = gtk_radio_button_new(group);
				/* ܥOFFˤ */
				gtk_toggle_button_set_mode(GTK_TOGGLE_BUTTON(button), FALSE);
			}
			
			/* "clicked" ٥ȥϥɥ */
			gtk_signal_connect( GTK_OBJECT(button), "clicked",
								GTK_SIGNAL_FUNC(Item->func),
								NULL );
		}


		/* ܥ˥ԥåޥåפŽդ */
		gtk_container_add(GTK_CONTAINER(button), gtkPixmap);
		
		/* ġС˥ܥɲ */
		gtk_toolbar_append_widget( GTK_TOOLBAR(toolbar),	/* toolbar */
								   GTK_WIDGET(button),		/* widget */
								   Item->tooltips,			/* tooltip text */
								   NULL);					/* tooltip private txt */
		
		/* ܥȥԥåޥåפĻ֤ */
		gtk_widget_show(GTK_WIDGET(button));
		gtk_widget_show(GTK_WIDGET(gtkPixmap));
		
		
		/*  */
		Item++;
	}
}





/* ====================================================================
 * ===  Copyright (C) 1998-2002 Yutaka Sagiya. All rights reserved. ===
 * ====================================================================
 *    Project              : sagcad
 *    Description          : CAD/CAM
 *    Source               : toolbar.c
 * ====================================================================
 */
